/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse         hlsl_parse
#define yylex           hlsl_lex
#define yyerror         hlsl_error
#define yylval          hlsl_lval
#define yychar          hlsl_char
#define yydebug         hlsl_debug
#define yynerrs         hlsl_nerrs
#define yylloc          hlsl_lloc

/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 21 "hlsl.y"

#include "config.h"
#include "wine/debug.h"

#include <stdio.h>

#include "d3dcompiler_private.h"

WINE_DEFAULT_DEBUG_CHANNEL(hlsl_parser);

int hlsl_lex(void);

struct hlsl_parse_ctx hlsl_ctx;

struct YYLTYPE;
static void set_location(struct source_location *loc, const struct YYLTYPE *l);

void hlsl_message(const char *fmt, ...)
{
    va_list args;

    va_start(args, fmt);
    compilation_message(&hlsl_ctx.messages, fmt, args);
    va_end(args);
}

static const char *hlsl_get_error_level_name(enum hlsl_error_level level)
{
    const char *names[] =
    {
        "error",
        "warning",
        "note",
    };
    return names[level];
}

void hlsl_report_message(const char *filename, DWORD line, DWORD column,
        enum hlsl_error_level level, const char *fmt, ...)
{
    va_list args;
    char *string = NULL;
    int rc, size = 0;

    while (1)
    {
        va_start(args, fmt);
        rc = vsnprintf(string, size, fmt, args);
        va_end(args);

        if (rc >= 0 && rc < size)
            break;

        if (rc >= size)
            size = rc + 1;
        else
            size = size ? size * 2 : 32;

        if (!string)
            string = d3dcompiler_alloc(size);
        else
            string = d3dcompiler_realloc(string, size);
        if (!string)
        {
            ERR("Error reallocating memory for a string.\n");
            return;
        }
    }

    hlsl_message("%s:%u:%u: %s: %s\n", filename, line, column, hlsl_get_error_level_name(level), string);
    d3dcompiler_free(string);

    if (level == HLSL_LEVEL_ERROR)
        set_parse_status(&hlsl_ctx.status, PARSE_ERR);
    else if (level == HLSL_LEVEL_WARNING)
        set_parse_status(&hlsl_ctx.status, PARSE_WARN);
}

static void hlsl_error(const char *s)
{
    hlsl_report_message(hlsl_ctx.source_file, hlsl_ctx.line_no, hlsl_ctx.column, HLSL_LEVEL_ERROR, "%s", s);
}

static void debug_dump_decl(struct hlsl_type *type, DWORD modifiers, const char *declname, unsigned int line_no)
{
    TRACE("Line %u: ", line_no);
    if (modifiers)
        TRACE("%s ", debug_modifiers(modifiers));
    TRACE("%s %s;\n", debug_hlsl_type(type), declname);
}

static void check_invalid_matrix_modifiers(DWORD modifiers, struct source_location *loc)
{
    if (modifiers & (HLSL_MODIFIER_ROW_MAJOR | HLSL_MODIFIER_COLUMN_MAJOR))
    {
        hlsl_report_message(loc->file, loc->line, loc->col, HLSL_LEVEL_ERROR,
                "'row_major' or 'column_major' modifiers are only allowed for matrices");
    }
}

static BOOL declare_variable(struct hlsl_ir_var *decl, BOOL local)
{
    BOOL ret;

    TRACE("Declaring variable %s.\n", decl->name);
    if (decl->node.data_type->type == HLSL_CLASS_MATRIX)
    {
        if (!(decl->modifiers & (HLSL_MODIFIER_ROW_MAJOR | HLSL_MODIFIER_COLUMN_MAJOR)))
        {
            decl->modifiers |= hlsl_ctx.matrix_majority == HLSL_ROW_MAJOR
                    ? HLSL_MODIFIER_ROW_MAJOR : HLSL_MODIFIER_COLUMN_MAJOR;
        }
    }
    else
        check_invalid_matrix_modifiers(decl->modifiers, &decl->node.loc);

    if (local)
    {
        DWORD invalid = decl->modifiers & (HLSL_STORAGE_EXTERN | HLSL_STORAGE_SHARED
                | HLSL_STORAGE_GROUPSHARED | HLSL_STORAGE_UNIFORM);
        if (invalid)
        {
            hlsl_report_message(decl->node.loc.file, decl->node.loc.line, decl->node.loc.col, HLSL_LEVEL_ERROR,
                    "modifier '%s' invalid for local variables", debug_modifiers(invalid));
        }
        if (decl->semantic)
        {
            hlsl_report_message(decl->node.loc.file, decl->node.loc.line, decl->node.loc.col, HLSL_LEVEL_ERROR,
                    "semantics are not allowed on local variables");
            return FALSE;
        }
    }
    else
    {
        if (find_function(decl->name))
        {
            hlsl_report_message(decl->node.loc.file, decl->node.loc.line, decl->node.loc.col, HLSL_LEVEL_ERROR,
                    "redefinition of '%s'", decl->name);
            return FALSE;
        }
    }
    ret = add_declaration(hlsl_ctx.cur_scope, decl, local);
    if (!ret)
    {
        struct hlsl_ir_var *old = get_variable(hlsl_ctx.cur_scope, decl->name);

        hlsl_report_message(decl->node.loc.file, decl->node.loc.line, decl->node.loc.col, HLSL_LEVEL_ERROR,
                "\"%s\" already declared", decl->name);
        hlsl_report_message(old->node.loc.file, old->node.loc.line, old->node.loc.col, HLSL_LEVEL_NOTE,
                "\"%s\" was previously declared here", old->name);
        return FALSE;
    }
    return TRUE;
}

static DWORD add_modifier(DWORD modifiers, DWORD mod, const struct YYLTYPE *loc);

static BOOL check_type_modifiers(DWORD modifiers, struct source_location *loc)
{
    if (modifiers & ~HLSL_TYPE_MODIFIERS_MASK)
    {
        hlsl_report_message(loc->file, loc->line, loc->col, HLSL_LEVEL_ERROR,
                "modifier not allowed on typedefs");
        return FALSE;
    }
    return TRUE;
}

static BOOL add_type_to_scope(struct hlsl_scope *scope, struct hlsl_type *def)
{
    if (get_type(scope, def->name, FALSE))
        return FALSE;

    wine_rb_put(&scope->types, def->name, &def->scope_entry);
    return TRUE;
}

static void declare_predefined_types(struct hlsl_scope *scope)
{
    struct hlsl_type *type;
    unsigned int x, y, bt;
    static const char *names[] =
    {
        "float",
        "half",
        "double",
        "int",
        "uint",
        "bool",
    };
    char name[10];

    for (bt = 0; bt <= HLSL_TYPE_LAST_SCALAR; ++bt)
    {
        for (y = 1; y <= 4; ++y)
        {
            for (x = 1; x <= 4; ++x)
            {
                sprintf(name, "%s%ux%u", names[bt], x, y);
                type = new_hlsl_type(d3dcompiler_strdup(name), HLSL_CLASS_MATRIX, bt, x, y);
                add_type_to_scope(scope, type);

                if (y == 1)
                {
                    sprintf(name, "%s%u", names[bt], x);
                    type = new_hlsl_type(d3dcompiler_strdup(name), HLSL_CLASS_VECTOR, bt, x, y);
                    add_type_to_scope(scope, type);

                    if (x == 1)
                    {
                        sprintf(name, "%s", names[bt]);
                        type = new_hlsl_type(d3dcompiler_strdup(name), HLSL_CLASS_SCALAR, bt, x, y);
                        add_type_to_scope(scope, type);
                    }
                }
            }
        }
    }

    /* DX8 effects predefined types */
    type = new_hlsl_type(d3dcompiler_strdup("DWORD"), HLSL_CLASS_SCALAR, HLSL_TYPE_INT, 1, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("FLOAT"), HLSL_CLASS_SCALAR, HLSL_TYPE_FLOAT, 1, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("VECTOR"), HLSL_CLASS_VECTOR, HLSL_TYPE_FLOAT, 4, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("MATRIX"), HLSL_CLASS_MATRIX, HLSL_TYPE_FLOAT, 4, 4);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("STRING"), HLSL_CLASS_OBJECT, HLSL_TYPE_STRING, 1, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("TEXTURE"), HLSL_CLASS_OBJECT, HLSL_TYPE_TEXTURE, 1, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("PIXELSHADER"), HLSL_CLASS_OBJECT, HLSL_TYPE_PIXELSHADER, 1, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("VERTEXSHADER"), HLSL_CLASS_OBJECT, HLSL_TYPE_VERTEXSHADER, 1, 1);
    add_type_to_scope(scope, type);
}

static struct hlsl_ir_if *loop_condition(struct list *cond_list)
{
    struct hlsl_ir_if *out_cond;
    struct hlsl_ir_expr *not_cond;
    struct hlsl_ir_node *cond, *operands[3];
    struct hlsl_ir_jump *jump;
    unsigned int count = list_count(cond_list);

    if (!count)
        return NULL;
    if (count != 1)
        ERR("Got multiple expressions in a for condition.\n");

    cond = LIST_ENTRY(list_head(cond_list), struct hlsl_ir_node, entry);
    out_cond = d3dcompiler_alloc(sizeof(*out_cond));
    if (!out_cond)
    {
        ERR("Out of memory.\n");
        return NULL;
    }
    out_cond->node.type = HLSL_IR_IF;
    operands[0] = cond;
    operands[1] = operands[2] = NULL;
    not_cond = new_expr(HLSL_IR_UNOP_LOGIC_NOT, operands, &cond->loc);
    if (!not_cond)
    {
        ERR("Out of memory.\n");
        d3dcompiler_free(out_cond);
        return NULL;
    }
    out_cond->condition = &not_cond->node;
    jump = d3dcompiler_alloc(sizeof(*jump));
    if (!jump)
    {
        ERR("Out of memory.\n");
        d3dcompiler_free(out_cond);
        d3dcompiler_free(not_cond);
        return NULL;
    }
    jump->node.type = HLSL_IR_JUMP;
    jump->type = HLSL_IR_JUMP_BREAK;
    out_cond->then_instrs = d3dcompiler_alloc(sizeof(*out_cond->then_instrs));
    if (!out_cond->then_instrs)
    {
        ERR("Out of memory.\n");
        d3dcompiler_free(out_cond);
        d3dcompiler_free(not_cond);
        d3dcompiler_free(jump);
        return NULL;
    }
    list_init(out_cond->then_instrs);
    list_add_head(out_cond->then_instrs, &jump->node.entry);

    return out_cond;
}

enum loop_type
{
    LOOP_FOR,
    LOOP_WHILE,
    LOOP_DO_WHILE
};

static struct list *create_loop(enum loop_type type, struct list *init, struct list *cond,
        struct list *iter, struct list *body, struct source_location *loc)
{
    struct list *list = NULL;
    struct hlsl_ir_loop *loop = NULL;
    struct hlsl_ir_if *cond_jump = NULL;

    list = d3dcompiler_alloc(sizeof(*list));
    if (!list)
        goto oom;
    list_init(list);

    if (init)
        list_move_head(list, init);

    loop = d3dcompiler_alloc(sizeof(*loop));
    if (!loop)
        goto oom;
    loop->node.type = HLSL_IR_LOOP;
    loop->node.loc = *loc;
    list_add_tail(list, &loop->node.entry);
    loop->body = d3dcompiler_alloc(sizeof(*loop->body));
    if (!loop->body)
        goto oom;
    list_init(loop->body);

    cond_jump = loop_condition(cond);
    if (!cond_jump)
        goto oom;

    if (type != LOOP_DO_WHILE)
        list_add_tail(loop->body, &cond_jump->node.entry);

    list_move_tail(loop->body, body);

    if (iter)
        list_move_tail(loop->body, iter);

    if (type == LOOP_DO_WHILE)
        list_add_tail(loop->body, &cond_jump->node.entry);

    d3dcompiler_free(init);
    d3dcompiler_free(cond);
    d3dcompiler_free(iter);
    d3dcompiler_free(body);
    return list;

oom:
    ERR("Out of memory.\n");
    if (loop)
        d3dcompiler_free(loop->body);
    d3dcompiler_free(loop);
    d3dcompiler_free(cond_jump);
    d3dcompiler_free(list);
    free_instr_list(init);
    free_instr_list(cond);
    free_instr_list(iter);
    free_instr_list(body);
    return NULL;
}

static unsigned int initializer_size(struct list *initializer)
{
    unsigned int count = 0;
    struct hlsl_ir_node *node;

    LIST_FOR_EACH_ENTRY(node, initializer, struct hlsl_ir_node, entry)
    {
        count += components_count_type(node->data_type);
    }
    TRACE("Initializer size = %u\n", count);
    return count;
}

static unsigned int components_count_expr_list(struct list *list)
{
    struct hlsl_ir_node *node;
    unsigned int count = 0;

    LIST_FOR_EACH_ENTRY(node, list, struct hlsl_ir_node, entry)
    {
        count += components_count_type(node->data_type);
    }
    return count;
}

static struct hlsl_ir_swizzle *new_swizzle(DWORD s, unsigned int components,
        struct hlsl_ir_node *val, struct source_location *loc)
{
    struct hlsl_ir_swizzle *swizzle = d3dcompiler_alloc(sizeof(*swizzle));

    if (!swizzle)
        return NULL;
    swizzle->node.type = HLSL_IR_SWIZZLE;
    swizzle->node.loc = *loc;
    swizzle->node.data_type = new_hlsl_type(NULL, HLSL_CLASS_VECTOR, val->data_type->base_type, components, 1);
    swizzle->val = val;
    swizzle->swizzle = s;
    return swizzle;
}

static struct hlsl_ir_swizzle *get_swizzle(struct hlsl_ir_node *value, const char *swizzle,
        struct source_location *loc)
{
    unsigned int len = strlen(swizzle), component = 0;
    unsigned int i, set, swiz = 0;
    BOOL valid;

    if (value->data_type->type == HLSL_CLASS_MATRIX)
    {
        /* Matrix swizzle */
        BOOL m_swizzle;
        unsigned int inc, x, y;

        if (len < 3 || swizzle[0] != '_')
            return NULL;
        m_swizzle = swizzle[1] == 'm';
        inc = m_swizzle ? 4 : 3;

        if (len % inc || len > inc * 4)
            return NULL;

        for (i = 0; i < len; i += inc)
        {
            if (swizzle[i] != '_')
                return NULL;
            if (m_swizzle)
            {
                if (swizzle[i + 1] != 'm')
                    return NULL;
                x = swizzle[i + 2] - '0';
                y = swizzle[i + 3] - '0';
            }
            else
            {
                x = swizzle[i + 1] - '1';
                y = swizzle[i + 2] - '1';
            }

            if (x >= value->data_type->dimx || y >= value->data_type->dimy)
                return NULL;
            swiz |= (y << 4 | x) << component * 8;
            component++;
        }
        return new_swizzle(swiz, component, value, loc);
    }

    /* Vector swizzle */
    if (len > 4)
        return NULL;

    for (set = 0; set < 2; ++set)
    {
        valid = TRUE;
        component = 0;
        for (i = 0; i < len; ++i)
        {
            char c[2][4] = {{'x', 'y', 'z', 'w'}, {'r', 'g', 'b', 'a'}};
            unsigned int s = 0;

            for (s = 0; s < 4; ++s)
            {
                if (swizzle[i] == c[set][s])
                    break;
            }
            if (s == 4)
            {
                valid = FALSE;
                break;
            }

            if (s >= value->data_type->dimx)
                return NULL;
            swiz |= s << component * 2;
            component++;
        }
        if (valid)
            return new_swizzle(swiz, component, value, loc);
    }

    return NULL;
}

static void struct_var_initializer(struct list *list, struct hlsl_ir_var *var, struct list *initializer)
{
    struct hlsl_type *type = var->node.data_type;
    struct hlsl_ir_node *node;
    struct hlsl_struct_field *field;
    struct list *cur_node;
    struct hlsl_ir_node *assignment;
    struct hlsl_ir_deref *deref;

    if (initializer_size(initializer) != components_count_type(type))
    {
        hlsl_report_message(var->node.loc.file, var->node.loc.line, var->node.loc.col, HLSL_LEVEL_ERROR,
                "structure initializer mismatch");
        free_instr_list(initializer);
        return;
    }
    cur_node = list_head(initializer);
    assert(cur_node);
    node = LIST_ENTRY(cur_node, struct hlsl_ir_node, entry);
    LIST_FOR_EACH_ENTRY(field, type->e.elements, struct hlsl_struct_field, entry)
    {
        if (!cur_node)
        {
            d3dcompiler_free(initializer);
            return;
        }
        if (components_count_type(field->type) == components_count_type(node->data_type))
        {
            deref = new_record_deref(&var->node, field);
            if (!deref)
            {
                ERR("Out of memory.\n");
                break;
            }
            deref->node.loc = node->loc;
            assignment = make_assignment(&deref->node, ASSIGN_OP_ASSIGN, BWRITERSP_WRITEMASK_ALL, node);
            list_add_tail(list, &assignment->entry);
        }
        else
            FIXME("Initializing with \"mismatched\" fields is not supported yet.\n");
        cur_node = list_next(initializer, cur_node);
        node = LIST_ENTRY(cur_node, struct hlsl_ir_node, entry);
    }

    /* Free initializer elements in excess. */
    while (cur_node)
    {
        struct list *next = list_next(initializer, cur_node);
        free_instr(node);
        cur_node = next;
        node = LIST_ENTRY(cur_node, struct hlsl_ir_node, entry);
    }
    d3dcompiler_free(initializer);
}

static struct list *declare_vars(struct hlsl_type *basic_type, DWORD modifiers, struct list *var_list)
{
    struct hlsl_type *type;
    struct parse_variable_def *v, *v_next;
    struct hlsl_ir_var *var;
    struct hlsl_ir_node *assignment;
    BOOL ret, local = TRUE;
    struct list *statements_list = d3dcompiler_alloc(sizeof(*statements_list));

    if (!statements_list)
    {
        ERR("Out of memory.\n");
        LIST_FOR_EACH_ENTRY_SAFE(v, v_next, var_list, struct parse_variable_def, entry)
            d3dcompiler_free(v);
        d3dcompiler_free(var_list);
        return NULL;
    }
    list_init(statements_list);

    if (!var_list)
        return statements_list;

    LIST_FOR_EACH_ENTRY_SAFE(v, v_next, var_list, struct parse_variable_def, entry)
    {
        var = d3dcompiler_alloc(sizeof(*var));
        if (!var)
        {
            ERR("Out of memory.\n");
            d3dcompiler_free(v);
            continue;
        }
        var->node.type = HLSL_IR_VAR;
        if (v->array_size)
            type = new_array_type(basic_type, v->array_size);
        else
            type = basic_type;
        var->node.data_type = type;
        var->node.loc = v->loc;
        var->name = v->name;
        var->modifiers = modifiers;
        var->semantic = v->semantic;
        debug_dump_decl(type, modifiers, v->name, v->loc.line);

        if (hlsl_ctx.cur_scope == hlsl_ctx.globals)
        {
            var->modifiers |= HLSL_STORAGE_UNIFORM;
            local = FALSE;
        }

        if (var->modifiers & HLSL_MODIFIER_CONST && !v->initializer)
        {
            hlsl_report_message(v->loc.file, v->loc.line, v->loc.col,
                    HLSL_LEVEL_ERROR, "const variable without initializer");
            free_declaration(var);
            d3dcompiler_free(v);
            continue;
        }

        ret = declare_variable(var, local);
        if (!ret)
        {
            free_declaration(var);
            d3dcompiler_free(v);
            continue;
        }
        TRACE("Declared variable %s.\n", var->name);

        if (v->initializer)
        {
            unsigned int size = initializer_size(v->initializer);
            struct hlsl_ir_node *node;

            TRACE("Variable with initializer.\n");
            if (type->type <= HLSL_CLASS_LAST_NUMERIC
                    && type->dimx * type->dimy != size && size != 1)
            {
                if (size < type->dimx * type->dimy)
                {
                    hlsl_report_message(v->loc.file, v->loc.line, v->loc.col, HLSL_LEVEL_ERROR,
                            "'%s' initializer does not match", v->name);
                    free_instr_list(v->initializer);
                    d3dcompiler_free(v);
                    continue;
                }
            }
            if ((type->type == HLSL_CLASS_STRUCT || type->type == HLSL_CLASS_ARRAY)
                    && components_count_type(type) != size)
            {
                hlsl_report_message(v->loc.file, v->loc.line, v->loc.col, HLSL_LEVEL_ERROR,
                        "'%s' initializer does not match", v->name);
                free_instr_list(v->initializer);
                d3dcompiler_free(v);
                continue;
            }

            if (type->type == HLSL_CLASS_STRUCT)
            {
                struct_var_initializer(statements_list, var, v->initializer);
                d3dcompiler_free(v);
                continue;
            }
            if (type->type > HLSL_CLASS_LAST_NUMERIC)
            {
                FIXME("Initializers for non scalar/struct variables not supported yet.\n");
                free_instr_list(v->initializer);
                d3dcompiler_free(v);
                continue;
            }
            if (v->array_size > 0)
            {
                FIXME("Initializing arrays is not supported yet.\n");
                free_instr_list(v->initializer);
                d3dcompiler_free(v);
                continue;
            }
            if (list_count(v->initializer) > 1)
            {
                FIXME("Complex initializers are not supported yet.\n");
                free_instr_list(v->initializer);
                d3dcompiler_free(v);
                continue;
            }
            node = LIST_ENTRY(list_head(v->initializer), struct hlsl_ir_node, entry);
            assignment = make_assignment(&var->node, ASSIGN_OP_ASSIGN,
                    BWRITERSP_WRITEMASK_ALL, node);
            list_add_tail(statements_list, &assignment->entry);
            d3dcompiler_free(v->initializer);
        }
        d3dcompiler_free(v);
    }
    d3dcompiler_free(var_list);
    return statements_list;
}

static BOOL add_struct_field(struct list *fields, struct hlsl_struct_field *field)
{
    struct hlsl_struct_field *f;

    LIST_FOR_EACH_ENTRY(f, fields, struct hlsl_struct_field, entry)
    {
        if (!strcmp(f->name, field->name))
            return FALSE;
    }
    list_add_tail(fields, &field->entry);
    return TRUE;
}

static struct list *gen_struct_fields(struct hlsl_type *type, DWORD modifiers, struct list *fields)
{
    struct parse_variable_def *v, *v_next;
    struct hlsl_struct_field *field;
    struct list *list;

    list = d3dcompiler_alloc(sizeof(*list));
    if (!list)
    {
        ERR("Out of memory.\n");
        return NULL;
    }
    list_init(list);
    LIST_FOR_EACH_ENTRY_SAFE(v, v_next, fields, struct parse_variable_def, entry)
    {
        debug_dump_decl(type, 0, v->name, v->loc.line);
        field = d3dcompiler_alloc(sizeof(*field));
        if (!field)
        {
            ERR("Out of memory.\n");
            d3dcompiler_free(v);
            return list;
        }
        field->type = type;
        field->name = v->name;
        field->modifiers = modifiers;
        field->semantic = v->semantic;
        if (v->initializer)
        {
            hlsl_report_message(v->loc.file, v->loc.line, v->loc.col, HLSL_LEVEL_ERROR,
                    "struct field with an initializer.\n");
            free_instr_list(v->initializer);
        }
        list_add_tail(list, &field->entry);
        d3dcompiler_free(v);
    }
    d3dcompiler_free(fields);
    return list;
}

static struct hlsl_type *new_struct_type(const char *name, DWORD modifiers, struct list *fields)
{
    struct hlsl_type *type = d3dcompiler_alloc(sizeof(*type));

    if (!type)
    {
        ERR("Out of memory.\n");
        return NULL;
    }
    type->type = HLSL_CLASS_STRUCT;
    type->name = name;
    type->dimx = type->dimy = 1;
    type->modifiers = modifiers;
    type->e.elements = fields;

    list_add_tail(&hlsl_ctx.types, &type->entry);

    return type;
}

static BOOL add_typedef(DWORD modifiers, struct hlsl_type *orig_type, struct list *list,
        struct source_location *loc)
{
    BOOL ret;
    struct hlsl_type *type;
    struct parse_variable_def *v, *v_next;

    if (!check_type_modifiers(modifiers, loc))
    {
        LIST_FOR_EACH_ENTRY_SAFE(v, v_next, list, struct parse_variable_def, entry)
            d3dcompiler_free(v);
        d3dcompiler_free(list);
        return FALSE;
    }

    LIST_FOR_EACH_ENTRY_SAFE(v, v_next, list, struct parse_variable_def, entry)
    {
        if (v->array_size)
            type = new_array_type(orig_type, v->array_size);
        else
            type = clone_hlsl_type(orig_type);
        if (!type)
        {
            ERR("Out of memory\n");
            return FALSE;
        }
        d3dcompiler_free((void *)type->name);
        type->name = v->name;
        type->modifiers |= modifiers;

        if (type->type != HLSL_CLASS_MATRIX)
            check_invalid_matrix_modifiers(type->modifiers, &v->loc);

        ret = add_type_to_scope(hlsl_ctx.cur_scope, type);
        if (!ret)
        {
            hlsl_report_message(v->loc.file, v->loc.line, v->loc.col, HLSL_LEVEL_ERROR,
                    "redefinition of custom type '%s'", v->name);
        }
        d3dcompiler_free(v);
    }
    d3dcompiler_free(list);
    return TRUE;
}



/* Line 268 of yacc.c  */
#line 873 "hlsl.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     KW_BLENDSTATE = 258,
     KW_BREAK = 259,
     KW_BUFFER = 260,
     KW_CBUFFER = 261,
     KW_COLUMN_MAJOR = 262,
     KW_COMPILE = 263,
     KW_CONST = 264,
     KW_CONTINUE = 265,
     KW_DEPTHSTENCILSTATE = 266,
     KW_DEPTHSTENCILVIEW = 267,
     KW_DISCARD = 268,
     KW_DO = 269,
     KW_DOUBLE = 270,
     KW_ELSE = 271,
     KW_EXTERN = 272,
     KW_FALSE = 273,
     KW_FOR = 274,
     KW_GEOMETRYSHADER = 275,
     KW_GROUPSHARED = 276,
     KW_IF = 277,
     KW_IN = 278,
     KW_INLINE = 279,
     KW_INOUT = 280,
     KW_MATRIX = 281,
     KW_NAMESPACE = 282,
     KW_NOINTERPOLATION = 283,
     KW_OUT = 284,
     KW_PASS = 285,
     KW_PIXELSHADER = 286,
     KW_PRECISE = 287,
     KW_RASTERIZERSTATE = 288,
     KW_RENDERTARGETVIEW = 289,
     KW_RETURN = 290,
     KW_REGISTER = 291,
     KW_ROW_MAJOR = 292,
     KW_SAMPLER = 293,
     KW_SAMPLER1D = 294,
     KW_SAMPLER2D = 295,
     KW_SAMPLER3D = 296,
     KW_SAMPLERCUBE = 297,
     KW_SAMPLER_STATE = 298,
     KW_SAMPLERCOMPARISONSTATE = 299,
     KW_SHARED = 300,
     KW_STATEBLOCK = 301,
     KW_STATEBLOCK_STATE = 302,
     KW_STATIC = 303,
     KW_STRING = 304,
     KW_STRUCT = 305,
     KW_SWITCH = 306,
     KW_TBUFFER = 307,
     KW_TECHNIQUE = 308,
     KW_TECHNIQUE10 = 309,
     KW_TEXTURE = 310,
     KW_TEXTURE1D = 311,
     KW_TEXTURE1DARRAY = 312,
     KW_TEXTURE2D = 313,
     KW_TEXTURE2DARRAY = 314,
     KW_TEXTURE2DMS = 315,
     KW_TEXTURE2DMSARRAY = 316,
     KW_TEXTURE3D = 317,
     KW_TEXTURE3DARRAY = 318,
     KW_TEXTURECUBE = 319,
     KW_TRUE = 320,
     KW_TYPEDEF = 321,
     KW_UNIFORM = 322,
     KW_VECTOR = 323,
     KW_VERTEXSHADER = 324,
     KW_VOID = 325,
     KW_VOLATILE = 326,
     KW_WHILE = 327,
     OP_INC = 328,
     OP_DEC = 329,
     OP_AND = 330,
     OP_OR = 331,
     OP_EQ = 332,
     OP_LEFTSHIFT = 333,
     OP_LEFTSHIFTASSIGN = 334,
     OP_RIGHTSHIFT = 335,
     OP_RIGHTSHIFTASSIGN = 336,
     OP_ELLIPSIS = 337,
     OP_LE = 338,
     OP_GE = 339,
     OP_NE = 340,
     OP_ADDASSIGN = 341,
     OP_SUBASSIGN = 342,
     OP_MULASSIGN = 343,
     OP_DIVASSIGN = 344,
     OP_MODASSIGN = 345,
     OP_ANDASSIGN = 346,
     OP_ORASSIGN = 347,
     OP_XORASSIGN = 348,
     OP_UNKNOWN1 = 349,
     OP_UNKNOWN2 = 350,
     OP_UNKNOWN3 = 351,
     OP_UNKNOWN4 = 352,
     PRE_LINE = 353,
     VAR_IDENTIFIER = 354,
     TYPE_IDENTIFIER = 355,
     NEW_IDENTIFIER = 356,
     STRING = 357,
     C_FLOAT = 358,
     C_INTEGER = 359
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 819 "hlsl.y"

    struct hlsl_type *type;
    INT intval;
    FLOAT floatval;
    BOOL boolval;
    char *name;
    DWORD modifiers;
    struct hlsl_ir_var *var;
    struct hlsl_ir_node *instr;
    struct list *list;
    struct hlsl_ir_function_decl *function;
    struct parse_parameter parameter;
    struct parse_variable_def *variable_def;
    struct parse_if_body if_body;
    enum parse_unary_op unary_op;
    enum parse_assign_op assign_op;



/* Line 293 of yacc.c  */
#line 1033 "hlsl.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 1058 "hlsl.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   697

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  129
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  62
/* YYNRULES -- Number of rules.  */
#define YYNRULES  168
/* YYNRULES -- Number of states.  */
#define YYNSTATES  308

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   359

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   120,     2,     2,     2,   124,   125,     2,
     108,   109,   122,   118,   111,   119,   117,   123,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   110,   105,
     112,   114,   113,   128,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   115,     2,   116,   126,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   106,   127,   107,   121,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     7,    10,    13,    16,    20,    22,
      24,    31,    37,    39,    41,    43,    44,    47,    52,    56,
      59,    62,    70,    73,    78,    79,    81,    83,    84,    87,
      89,    92,    94,    98,   104,   105,   107,   109,   111,   113,
     120,   129,   131,   133,   135,   137,   139,   141,   143,   146,
     148,   150,   152,   158,   163,   165,   169,   172,   177,   178,
     180,   182,   186,   190,   196,   197,   201,   202,   205,   208,
     211,   214,   217,   220,   223,   226,   229,   232,   235,   237,
     241,   243,   245,   249,   251,   253,   255,   258,   260,   262,
     264,   266,   268,   270,   274,   280,   282,   286,   292,   300,
     309,   318,   320,   323,   325,   327,   329,   331,   335,   337,
     339,   342,   345,   349,   354,   360,   362,   365,   368,   371,
     378,   380,   382,   384,   386,   388,   392,   396,   400,   402,
     406,   410,   412,   416,   420,   422,   426,   430,   434,   438,
     440,   444,   448,   450,   454,   456,   460,   462,   466,   468,
     472,   474,   478,   480,   486,   488,   492,   494,   496,   498,
     500,   502,   504,   506,   508,   510,   512,   514,   516
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     130,     0,    -1,    -1,   130,   139,    -1,   130,   151,    -1,
     130,   131,    -1,    98,   102,    -1,   133,   156,   105,    -1,
     134,    -1,   135,    -1,   160,    50,   136,   106,   137,   107,
      -1,   160,    50,   106,   137,   107,    -1,    99,    -1,   100,
      -1,   101,    -1,    -1,   137,   138,    -1,   160,   149,   157,
     105,    -1,   135,   157,   105,    -1,   140,   141,    -1,   140,
     105,    -1,   160,   149,   143,   108,   145,   109,   144,    -1,
     106,   107,    -1,   106,   142,   165,   107,    -1,    -1,    99,
      -1,   101,    -1,    -1,   110,   136,    -1,   142,    -1,   142,
     146,    -1,   147,    -1,   146,   111,   147,    -1,   148,   160,
     149,   136,   144,    -1,    -1,    23,    -1,    29,    -1,    25,
      -1,   150,    -1,    68,   112,   150,   111,   104,   113,    -1,
      26,   112,   150,   111,   104,   111,   104,   113,    -1,    70,
      -1,    38,    -1,    39,    -1,    40,    -1,    41,    -1,    42,
      -1,   100,    -1,    50,   100,    -1,   155,    -1,   132,    -1,
     152,    -1,    66,   160,   149,   153,   105,    -1,    66,   133,
     153,   105,    -1,   154,    -1,   153,   111,   154,    -1,   136,
     159,    -1,   160,   149,   157,   105,    -1,    -1,   157,    -1,
     158,    -1,   157,   111,   158,    -1,   136,   159,   144,    -1,
     136,   159,   144,   114,   161,    -1,    -1,   115,   190,   116,
      -1,    -1,    17,   160,    -1,    28,   160,    -1,    32,   160,
      -1,    45,   160,    -1,    21,   160,    -1,    48,   160,    -1,
      67,   160,    -1,    71,   160,    -1,     9,   160,    -1,    37,
     160,    -1,     7,   160,    -1,   162,    -1,   106,   163,   107,
      -1,   188,    -1,   162,    -1,   163,   111,   162,    -1,    65,
      -1,    18,    -1,   166,    -1,   165,   166,    -1,   151,    -1,
     171,    -1,   141,    -1,   167,    -1,   168,    -1,   170,    -1,
      35,   190,   105,    -1,    22,   108,   190,   109,   169,    -1,
     166,    -1,   166,    16,   166,    -1,    72,   108,   190,   109,
     166,    -1,    14,   166,    72,   108,   190,   109,   105,    -1,
      19,   108,   142,   171,   171,   171,   109,   166,    -1,    19,
     108,   142,   155,   171,   171,   109,   166,    -1,   105,    -1,
     190,   105,    -1,   103,    -1,   104,    -1,   164,    -1,   173,
      -1,   108,   190,   109,    -1,    99,    -1,   172,    -1,   174,
      73,    -1,   174,    74,    -1,   174,   117,   136,    -1,   174,
     115,   190,   116,    -1,   160,   149,   108,   163,   109,    -1,
     174,    -1,    73,   175,    -1,    74,   175,    -1,   176,   175,
      -1,   108,   160,   149,   159,   109,   175,    -1,   118,    -1,
     119,    -1,   120,    -1,   121,    -1,   175,    -1,   177,   122,
     175,    -1,   177,   123,   175,    -1,   177,   124,   175,    -1,
     177,    -1,   178,   118,   177,    -1,   178,   119,   177,    -1,
     178,    -1,   179,    78,   178,    -1,   179,    80,   178,    -1,
     179,    -1,   180,   112,   179,    -1,   180,   113,   179,    -1,
     180,    83,   179,    -1,   180,    84,   179,    -1,   180,    -1,
     181,    77,   180,    -1,   181,    85,   180,    -1,   181,    -1,
     182,   125,   181,    -1,   182,    -1,   183,   126,   182,    -1,
     183,    -1,   184,   127,   183,    -1,   184,    -1,   185,    75,
     184,    -1,   185,    -1,   186,    76,   185,    -1,   186,    -1,
     186,   128,   190,   110,   188,    -1,   187,    -1,   175,   189,
     188,    -1,   114,    -1,    86,    -1,    87,    -1,    88,    -1,
      89,    -1,    90,    -1,    79,    -1,    81,    -1,    91,    -1,
      92,    -1,    93,    -1,   188,    -1,   190,   111,   188,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   999,   999,  1001,  1006,  1010,  1014,  1033,  1050,  1051,
    1053,  1079,  1089,  1090,  1091,  1094,  1098,  1117,  1121,  1126,
    1133,  1140,  1163,  1168,  1175,  1179,  1180,  1183,  1186,  1191,
    1196,  1201,  1215,  1229,  1239,  1242,  1246,  1250,  1255,  1259,
    1278,  1298,  1302,  1307,  1312,  1317,  1322,  1327,  1336,  1355,
    1356,  1357,  1368,  1376,  1385,  1391,  1397,  1405,  1411,  1414,
    1419,  1425,  1431,  1439,  1451,  1454,  1462,  1465,  1469,  1473,
    1477,  1481,  1485,  1489,  1493,  1497,  1501,  1505,  1510,  1516,
    1521,  1526,  1532,  1538,  1542,  1547,  1551,  1558,  1559,  1560,
    1561,  1562,  1563,  1566,  1589,  1613,  1618,  1624,  1639,  1654,
    1662,  1674,  1679,  1687,  1701,  1715,  1729,  1740,  1745,  1759,
    1763,  1782,  1801,  1855,  1915,  1951,  1955,  1971,  1987,  2007,
    2039,  2043,  2047,  2051,  2056,  2060,  2067,  2074,  2082,  2086,
    2093,  2101,  2105,  2109,  2114,  2118,  2125,  2132,  2139,  2147,
    2151,  2158,  2166,  2170,  2175,  2179,  2184,  2188,  2193,  2197,
    2202,  2206,  2211,  2215,  2220,  2224,  2241,  2245,  2249,  2253,
    2257,  2261,  2265,  2269,  2273,  2277,  2281,  2286,  2290
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "KW_BLENDSTATE", "KW_BREAK", "KW_BUFFER",
  "KW_CBUFFER", "KW_COLUMN_MAJOR", "KW_COMPILE", "KW_CONST", "KW_CONTINUE",
  "KW_DEPTHSTENCILSTATE", "KW_DEPTHSTENCILVIEW", "KW_DISCARD", "KW_DO",
  "KW_DOUBLE", "KW_ELSE", "KW_EXTERN", "KW_FALSE", "KW_FOR",
  "KW_GEOMETRYSHADER", "KW_GROUPSHARED", "KW_IF", "KW_IN", "KW_INLINE",
  "KW_INOUT", "KW_MATRIX", "KW_NAMESPACE", "KW_NOINTERPOLATION", "KW_OUT",
  "KW_PASS", "KW_PIXELSHADER", "KW_PRECISE", "KW_RASTERIZERSTATE",
  "KW_RENDERTARGETVIEW", "KW_RETURN", "KW_REGISTER", "KW_ROW_MAJOR",
  "KW_SAMPLER", "KW_SAMPLER1D", "KW_SAMPLER2D", "KW_SAMPLER3D",
  "KW_SAMPLERCUBE", "KW_SAMPLER_STATE", "KW_SAMPLERCOMPARISONSTATE",
  "KW_SHARED", "KW_STATEBLOCK", "KW_STATEBLOCK_STATE", "KW_STATIC",
  "KW_STRING", "KW_STRUCT", "KW_SWITCH", "KW_TBUFFER", "KW_TECHNIQUE",
  "KW_TECHNIQUE10", "KW_TEXTURE", "KW_TEXTURE1D", "KW_TEXTURE1DARRAY",
  "KW_TEXTURE2D", "KW_TEXTURE2DARRAY", "KW_TEXTURE2DMS",
  "KW_TEXTURE2DMSARRAY", "KW_TEXTURE3D", "KW_TEXTURE3DARRAY",
  "KW_TEXTURECUBE", "KW_TRUE", "KW_TYPEDEF", "KW_UNIFORM", "KW_VECTOR",
  "KW_VERTEXSHADER", "KW_VOID", "KW_VOLATILE", "KW_WHILE", "OP_INC",
  "OP_DEC", "OP_AND", "OP_OR", "OP_EQ", "OP_LEFTSHIFT",
  "OP_LEFTSHIFTASSIGN", "OP_RIGHTSHIFT", "OP_RIGHTSHIFTASSIGN",
  "OP_ELLIPSIS", "OP_LE", "OP_GE", "OP_NE", "OP_ADDASSIGN", "OP_SUBASSIGN",
  "OP_MULASSIGN", "OP_DIVASSIGN", "OP_MODASSIGN", "OP_ANDASSIGN",
  "OP_ORASSIGN", "OP_XORASSIGN", "OP_UNKNOWN1", "OP_UNKNOWN2",
  "OP_UNKNOWN3", "OP_UNKNOWN4", "PRE_LINE", "VAR_IDENTIFIER",
  "TYPE_IDENTIFIER", "NEW_IDENTIFIER", "STRING", "C_FLOAT", "C_INTEGER",
  "';'", "'{'", "'}'", "'('", "')'", "':'", "','", "'<'", "'>'", "'='",
  "'['", "']'", "'.'", "'+'", "'-'", "'!'", "'~'", "'*'", "'/'", "'%'",
  "'&'", "'^'", "'|'", "'?'", "$accept", "hlsl_prog", "preproc_directive",
  "struct_declaration", "struct_spec", "named_struct_spec",
  "unnamed_struct_spec", "any_identifier", "fields_list", "field",
  "func_declaration", "func_prototype", "compound_statement",
  "scope_start", "var_identifier", "semantic", "parameters", "param_list",
  "parameter", "input_mod", "type", "base_type", "declaration_statement",
  "typedef", "type_specs", "type_spec", "declaration",
  "variables_def_optional", "variables_def", "variable_def", "array",
  "var_modifiers", "complex_initializer", "initializer_expr",
  "initializer_expr_list", "boolean", "statement_list", "statement",
  "jump_statement", "selection_statement", "if_body", "loop_statement",
  "expr_statement", "primary_expr", "variable", "postfix_expr",
  "unary_expr", "unary_op", "mul_expr", "add_expr", "shift_expr",
  "relational_expr", "equality_expr", "bitand_expr", "bitxor_expr",
  "bitor_expr", "logicand_expr", "logicor_expr", "conditional_expr",
  "assignment_expr", "assign_op", "expr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,    59,   123,   125,    40,    41,
      58,    44,    60,    62,    61,    91,    93,    46,    43,    45,
      33,   126,    42,    47,    37,    38,    94,   124,    63
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   129,   130,   130,   130,   130,   131,   132,   133,   133,
     134,   135,   136,   136,   136,   137,   137,   138,   138,   139,
     139,   140,   141,   141,   142,   143,   143,   144,   144,   145,
     145,   146,   146,   147,   148,   148,   148,   148,   149,   149,
     149,   150,   150,   150,   150,   150,   150,   150,   150,   151,
     151,   151,   152,   152,   153,   153,   154,   155,   156,   156,
     157,   157,   158,   158,   159,   159,   160,   160,   160,   160,
     160,   160,   160,   160,   160,   160,   160,   160,   161,   161,
     162,   163,   163,   164,   164,   165,   165,   166,   166,   166,
     166,   166,   166,   167,   168,   169,   169,   170,   170,   170,
     170,   171,   171,   172,   172,   172,   172,   172,   173,   174,
     174,   174,   174,   174,   174,   175,   175,   175,   175,   175,
     176,   176,   176,   176,   177,   177,   177,   177,   178,   178,
     178,   179,   179,   179,   180,   180,   180,   180,   180,   181,
     181,   181,   182,   182,   183,   183,   184,   184,   185,   185,
     186,   186,   187,   187,   188,   188,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   190,   190
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     2,     3,     1,     1,
       6,     5,     1,     1,     1,     0,     2,     4,     3,     2,
       2,     7,     2,     4,     0,     1,     1,     0,     2,     1,
       2,     1,     3,     5,     0,     1,     1,     1,     1,     6,
       8,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     5,     4,     1,     3,     2,     4,     0,     1,
       1,     3,     3,     5,     0,     3,     0,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     3,
       1,     1,     3,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     3,     5,     1,     3,     5,     7,     8,
       8,     1,     2,     1,     1,     1,     1,     3,     1,     1,
       2,     2,     3,     4,     5,     1,     2,     2,     2,     6,
       1,     1,     1,     1,     1,     3,     3,     3,     1,     3,
       3,     1,     3,     3,     1,     3,     3,     3,     3,     1,
       3,     3,     1,     3,     1,     3,     1,     3,     1,     3,
       1,     3,     1,     5,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,    66,     1,    66,    66,    66,    66,    66,    66,    66,
      66,    66,    66,    66,    66,     0,     5,    50,    58,     8,
       9,     3,     0,     4,    51,    49,     0,    77,    75,    67,
      71,    68,    69,    76,    70,    72,     0,     0,    73,    74,
       6,    12,    13,    14,    64,     0,    59,    60,    20,    24,
      19,     0,    42,    43,    44,    45,    46,     0,     0,    41,
      47,     0,    38,    64,     0,    54,     0,    66,    27,     7,
       0,    22,    66,     0,    48,    15,     0,     0,    12,    14,
       0,     0,    56,    53,     0,     0,    84,    83,    66,    66,
     108,   103,   104,    66,   120,   121,   122,   123,     0,   105,
     109,   106,   115,   124,    66,   128,   131,   134,   139,   142,
     144,   146,   148,   150,   152,   154,   167,     0,     0,    62,
      61,    66,     0,     0,    66,     0,   101,    89,    87,     0,
      66,    85,    90,    91,    92,    88,     0,     0,     0,    66,
      15,     0,    24,    57,    55,    52,   116,   117,     0,     0,
       0,   110,   111,    66,     0,   162,   163,   157,   158,   159,
     160,   161,   164,   165,   166,   156,    66,   118,    66,    66,
      66,    66,    66,    66,    66,    66,    66,    66,    66,    66,
      66,    66,    66,    66,    66,    66,    66,    66,    65,    28,
      66,     0,    24,    66,     0,    66,     0,    23,    86,   102,
      48,     0,    11,     0,    16,     0,    66,     0,    34,     0,
      64,   107,    66,     0,   112,   155,   125,   126,   127,   124,
     129,   130,   132,   133,   137,   138,   135,   136,   140,   141,
     143,   145,   147,   149,   151,     0,   168,    66,    63,    78,
      80,     0,    66,     0,    93,     0,     0,     0,     0,     0,
      10,     0,    35,    37,    36,    30,    31,    66,    27,     0,
      81,     0,   113,    66,     0,    66,    66,     0,    66,    66,
      66,     0,    18,     0,    39,    34,     0,    21,    66,   114,
      66,   153,    79,     0,    66,    66,    95,    94,    97,     0,
      17,    32,     0,   119,    82,     0,     0,     0,    66,    40,
      27,    98,    66,    66,    96,    33,   100,    99
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    16,    17,    18,    19,    20,    44,   139,   204,
      21,    22,   127,    72,    80,   119,   209,   255,   256,   257,
     196,    62,   128,    24,    64,    65,    25,    45,    81,    47,
      68,    98,   238,   260,   261,    99,   130,   131,   132,   133,
     287,   134,   135,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     166,   136
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -229
static const yytype_int16 yypact[] =
{
    -229,   582,  -229,   626,   626,   626,   626,   626,   626,   626,
     626,   626,   626,   626,   626,   -64,  -229,  -229,   126,  -229,
    -229,  -229,   -29,  -229,  -229,  -229,    17,  -229,  -229,  -229,
    -229,  -229,  -229,  -229,  -229,  -229,   126,    17,  -229,  -229,
    -229,  -229,  -229,  -229,   -52,   -31,    -7,  -229,  -229,    -8,
    -229,   -28,  -229,  -229,  -229,  -229,  -229,    83,    11,  -229,
    -229,   184,  -229,   -52,    22,  -229,   126,   521,     4,  -229,
     126,  -229,   323,    -6,    24,  -229,    84,    -6,   115,   145,
     146,    26,  -229,  -229,   126,    29,  -229,  -229,   521,   521,
    -229,  -229,  -229,   521,  -229,  -229,  -229,  -229,   138,  -229,
    -229,  -229,   -27,   186,   521,   168,   -67,   -18,    12,   -40,
      70,   113,   121,   183,   -48,  -229,  -229,     2,   126,   147,
    -229,   323,   151,   154,   521,   158,  -229,  -229,  -229,    17,
     215,  -229,  -229,  -229,  -229,  -229,    58,   170,   182,    61,
    -229,   185,  -229,  -229,  -229,  -229,  -229,  -229,   138,    30,
     187,  -229,  -229,   521,   126,  -229,  -229,  -229,  -229,  -229,
    -229,  -229,  -229,  -229,  -229,  -229,   521,  -229,   521,   521,
     521,   521,   521,   521,   521,   521,   521,   521,   521,   521,
     521,   521,   521,   521,   521,   521,   521,   521,  -229,  -229,
     402,   222,  -229,   521,    86,   521,   -60,  -229,  -229,  -229,
    -229,   194,  -229,   126,  -229,   335,   164,   195,    -2,   196,
     -54,  -229,   521,    59,  -229,  -229,  -229,  -229,  -229,  -229,
     168,   168,   -67,   -67,   -18,   -18,   -18,   -18,    12,    12,
     -40,    70,   113,   121,   183,    76,  -229,   521,  -229,  -229,
    -229,   198,   442,    63,  -229,   119,   192,    99,   107,   126,
    -229,   191,  -229,  -229,  -229,   197,  -229,   626,     4,   200,
    -229,   131,  -229,   521,   -10,   521,   442,   138,   442,   323,
     323,   203,  -229,   106,  -229,    87,   138,  -229,   521,  -229,
     521,  -229,  -229,   140,   442,   442,   294,  -229,  -229,   199,
    -229,  -229,   126,  -229,  -229,   206,   204,   207,   323,  -229,
       4,  -229,   323,   323,  -229,  -229,  -229,  -229
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -229,  -229,  -229,  -229,   303,  -229,  -115,   -35,   177,  -229,
    -229,  -229,   302,  -123,  -229,  -228,  -229,  -229,    50,  -229,
     -12,    38,   325,  -229,   261,   244,    89,  -229,    -3,   259,
     -43,    -1,  -229,  -172,   101,  -229,  -229,  -104,  -229,  -229,
    -229,  -229,  -163,  -229,  -229,  -229,   -23,  -229,    31,    42,
      43,    65,   162,   157,   163,   165,   167,  -229,  -229,  -137,
    -229,   -51
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -30
static const yytype_int16 yytable[] =
{
      26,    63,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    37,    38,    39,    61,    46,   117,   191,   239,   208,
      82,   252,    76,   253,   203,    66,   198,   254,   185,   215,
     277,    63,    52,    53,    54,    55,    56,   179,    40,    41,
      42,    43,   149,    51,   137,   180,   151,   152,   212,    63,
     236,   171,   172,   240,   212,    52,    53,    54,    55,    56,
     173,    67,   174,    67,    59,   146,   147,    57,     3,   242,
       4,   129,   305,   194,    69,   240,    48,    49,     5,   268,
     186,   167,     6,   189,    73,    58,   150,    59,   153,     7,
     154,   203,   148,     8,    60,   175,   176,   282,     9,    71,
     240,   280,   213,   284,    70,   285,    10,   -29,   294,    11,
     252,   138,   253,   187,   118,   141,   254,    60,   188,   214,
     129,   296,   297,    77,   177,   178,   281,    83,    13,   129,
     -13,   143,    14,    84,   145,   235,   210,    70,   205,   211,
      84,   187,   243,   240,   245,   216,   217,   218,   219,   219,
     219,   219,   219,   219,   219,   219,   219,   219,   219,   219,
     219,   219,   219,   199,    51,   286,   288,   259,   202,   187,
     187,     3,   269,     4,   187,   262,    52,    53,    54,    55,
      56,     5,    41,    74,    43,     6,   263,   187,   137,    75,
     140,   244,     7,   249,   304,   181,     8,   187,   306,   307,
     247,     9,   220,   221,   272,   205,    58,   200,    59,    10,
      70,   290,    11,    75,   283,   222,   223,    70,   224,   225,
     226,   227,     3,   -25,     4,    41,    42,    43,   270,   121,
     187,    13,     5,    86,   122,    14,     6,   123,    60,   182,
     279,   267,   280,     7,   228,   229,   273,     8,   183,   295,
     124,   187,     9,   -26,   142,   293,   276,   300,   184,   192,
      10,   190,   193,    11,   292,   155,   195,   156,   129,   129,
     200,   250,   157,   158,   159,   160,   161,   162,   163,   164,
      87,    12,    13,    78,    42,    79,    14,   125,    88,    89,
     168,   169,   170,   201,   241,   212,   207,   129,   246,   251,
     165,   129,   129,   271,   274,   258,   265,   289,   275,   278,
     298,   301,   299,   302,    90,    36,   303,   206,    91,    92,
     126,    49,   197,    93,    50,   291,    23,    85,   144,   120,
       3,   266,     4,    94,    95,    96,    97,   121,   264,   231,
       5,    86,   122,   230,     6,   123,   232,     0,     0,   233,
       0,     7,   234,     0,     0,     8,     0,     0,   124,     0,
       9,    51,     0,     0,     0,     0,     0,     0,    10,     0,
       0,    11,     0,    52,    53,    54,    55,    56,     0,     0,
       0,     0,     0,     0,     0,   248,     0,     0,    87,    12,
      13,     0,     0,     0,    14,   125,    88,    89,     0,     0,
       0,     0,     0,    58,     0,    59,     0,     0,     0,     3,
       0,     4,     0,     0,     0,     0,     0,     0,     0,     5,
      86,     0,    90,     6,     0,     0,    91,    92,   126,    49,
       7,    93,     0,     0,     8,    60,     0,     0,     0,     9,
       0,    94,    95,    96,    97,     0,     0,    10,     0,     3,
      11,     4,     0,     0,     0,     0,     0,     0,     0,     5,
      86,     0,     0,     6,     0,     0,     0,    87,     0,    13,
       7,     0,     0,    14,     8,    88,    89,     0,     0,     9,
       0,     0,     0,     0,     0,     0,     0,    10,     0,     0,
      11,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    90,     0,     0,     0,    91,    92,    87,   237,    13,
      93,     0,     0,    14,     0,    88,    89,     0,     0,     0,
      94,    95,    96,    97,     0,     0,     0,     0,     3,     0,
       4,     0,     0,     0,     0,     0,     0,     0,     5,    86,
       0,    90,     6,     0,     0,    91,    92,   126,     0,     7,
      93,     0,     0,     8,     0,     0,     0,     0,     9,     0,
      94,    95,    96,    97,     0,     0,    10,     0,     0,    11,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     2,     0,     0,     0,    87,     0,    13,     3,
       0,     4,    14,     0,    88,    89,     0,     0,     0,     5,
       0,     0,     0,     6,     0,     0,     0,     0,     0,     0,
       7,     0,     0,     0,     8,     0,     0,     0,     0,     9,
      90,     0,     0,     0,    91,    92,     0,    10,     0,    93,
      11,     0,     0,     3,     0,     4,     0,     0,     0,    94,
      95,    96,    97,     5,     0,     0,     0,     6,    12,    13,
       0,     0,     0,    14,     7,     0,     0,     0,     8,     0,
       0,     0,     0,     9,     0,     0,     0,     0,     0,     0,
       0,    10,     0,     0,    11,     0,     0,     0,     0,     0,
      15,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    13,     0,     0,     0,    14
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-229))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       1,    36,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    26,    18,    67,   121,   190,   142,
      63,    23,    57,    25,   139,    37,   130,    29,    76,   166,
     258,    66,    38,    39,    40,    41,    42,    77,   102,    99,
     100,   101,    93,    26,    50,    85,    73,    74,   108,    84,
     187,   118,   119,   190,   108,    38,    39,    40,    41,    42,
      78,   115,    80,   115,    70,    88,    89,    50,     7,   192,
       9,    72,   300,   124,   105,   212,   105,   106,    17,   242,
     128,   104,    21,   118,   112,    68,    98,    70,   115,    28,
     117,   206,    93,    32,   100,    83,    84,   107,    37,   107,
     237,   111,   153,   266,   111,   268,    45,   109,   280,    48,
      23,    73,    25,   111,   110,    77,    29,   100,   116,   154,
     121,   284,   285,   112,   112,   113,   263,   105,    67,   130,
     106,   105,    71,   111,   105,   186,   148,   111,   139,   109,
     111,   111,   193,   280,   195,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   105,    26,   269,   270,   210,   107,   111,
     111,     7,   109,     9,   111,   116,    38,    39,    40,    41,
      42,    17,    99,   100,   101,    21,   110,   111,    50,   106,
     106,   105,    28,   205,   298,   125,    32,   111,   302,   303,
     203,    37,   171,   172,   105,   206,    68,   100,    70,    45,
     111,   105,    48,   106,   265,   173,   174,   111,   175,   176,
     177,   178,     7,   108,     9,    99,   100,   101,   109,    14,
     111,    67,    17,    18,    19,    71,    21,    22,   100,   126,
     109,   242,   111,    28,   179,   180,   249,    32,   127,   109,
      35,   111,    37,   108,   108,   278,   257,   292,    75,   108,
      45,   114,   108,    48,   276,    79,   108,    81,   269,   270,
     100,   107,    86,    87,    88,    89,    90,    91,    92,    93,
      65,    66,    67,    99,   100,   101,    71,    72,    73,    74,
     122,   123,   124,   111,    72,   108,   111,   298,   104,   104,
     114,   302,   303,   111,   113,   109,   108,   104,   111,   109,
      16,   105,   113,   109,    99,    12,   109,   140,   103,   104,
     105,   106,   107,   108,    22,   275,     1,    66,    84,    70,
       7,   242,     9,   118,   119,   120,   121,    14,   237,   182,
      17,    18,    19,   181,    21,    22,   183,    -1,    -1,   184,
      -1,    28,   185,    -1,    -1,    32,    -1,    -1,    35,    -1,
      37,    26,    -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      -1,    48,    -1,    38,    39,    40,    41,    42,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    50,    -1,    -1,    65,    66,
      67,    -1,    -1,    -1,    71,    72,    73,    74,    -1,    -1,
      -1,    -1,    -1,    68,    -1,    70,    -1,    -1,    -1,     7,
      -1,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,
      18,    -1,    99,    21,    -1,    -1,   103,   104,   105,   106,
      28,   108,    -1,    -1,    32,   100,    -1,    -1,    -1,    37,
      -1,   118,   119,   120,   121,    -1,    -1,    45,    -1,     7,
      48,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,
      18,    -1,    -1,    21,    -1,    -1,    -1,    65,    -1,    67,
      28,    -1,    -1,    71,    32,    73,    74,    -1,    -1,    37,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,
      48,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    99,    -1,    -1,    -1,   103,   104,    65,   106,    67,
     108,    -1,    -1,    71,    -1,    73,    74,    -1,    -1,    -1,
     118,   119,   120,   121,    -1,    -1,    -1,    -1,     7,    -1,
       9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,
      -1,    99,    21,    -1,    -1,   103,   104,   105,    -1,    28,
     108,    -1,    -1,    32,    -1,    -1,    -1,    -1,    37,    -1,
     118,   119,   120,   121,    -1,    -1,    45,    -1,    -1,    48,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     0,    -1,    -1,    -1,    65,    -1,    67,     7,
      -1,     9,    71,    -1,    73,    74,    -1,    -1,    -1,    17,
      -1,    -1,    -1,    21,    -1,    -1,    -1,    -1,    -1,    -1,
      28,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,    37,
      99,    -1,    -1,    -1,   103,   104,    -1,    45,    -1,   108,
      48,    -1,    -1,     7,    -1,     9,    -1,    -1,    -1,   118,
     119,   120,   121,    17,    -1,    -1,    -1,    21,    66,    67,
      -1,    -1,    -1,    71,    28,    -1,    -1,    -1,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    48,    -1,    -1,    -1,    -1,    -1,
      98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    -1,    -1,    -1,    71
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   130,     0,     7,     9,    17,    21,    28,    32,    37,
      45,    48,    66,    67,    71,    98,   131,   132,   133,   134,
     135,   139,   140,   151,   152,   155,   160,   160,   160,   160,
     160,   160,   160,   160,   160,   160,   133,   160,   160,   160,
     102,    99,   100,   101,   136,   156,   157,   158,   105,   106,
     141,    26,    38,    39,    40,    41,    42,    50,    68,    70,
     100,   149,   150,   136,   153,   154,   149,   115,   159,   105,
     111,   107,   142,   112,   100,   106,   136,   112,    99,   101,
     143,   157,   159,   105,   111,   153,    18,    65,    73,    74,
      99,   103,   104,   108,   118,   119,   120,   121,   160,   164,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   190,   110,   144,
     158,    14,    19,    22,    35,    72,   105,   141,   151,   160,
     165,   166,   167,   168,   170,   171,   190,    50,   150,   137,
     106,   150,   108,   105,   154,   105,   175,   175,   160,   190,
     149,    73,    74,   115,   117,    79,    81,    86,    87,    88,
      89,    90,    91,    92,    93,   114,   189,   175,   122,   123,
     124,   118,   119,    78,    80,    83,    84,   112,   113,    77,
      85,   125,   126,   127,    75,    76,   128,   111,   116,   136,
     114,   166,   108,   108,   190,   108,   149,   107,   166,   105,
     100,   111,   107,   135,   138,   160,   137,   111,   142,   145,
     149,   109,   108,   190,   136,   188,   175,   175,   175,   175,
     177,   177,   178,   178,   179,   179,   179,   179,   180,   180,
     181,   182,   183,   184,   185,   190,   188,   106,   161,   162,
     188,    72,   142,   190,   105,   190,   104,   157,    50,   149,
     107,   104,    23,    25,    29,   146,   147,   148,   109,   159,
     162,   163,   116,   110,   163,   108,   155,   160,   171,   109,
     109,   111,   105,   157,   113,   111,   160,   144,   109,   109,
     111,   188,   107,   190,   171,   171,   166,   169,   166,   104,
     105,   147,   149,   175,   162,   109,   171,   171,    16,   113,
     136,   105,   109,   109,   166,   144,   166,   166
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1806 of yacc.c  */
#line 999 "hlsl.y"
    {
                            }
    break;

  case 3:

/* Line 1806 of yacc.c  */
#line 1002 "hlsl.y"
    {
                                FIXME("Check that the function doesn't conflict with an already declared one.\n");
                                list_add_tail(&hlsl_ctx.functions, &(yyvsp[(2) - (2)].function)->node.entry);
                            }
    break;

  case 4:

/* Line 1806 of yacc.c  */
#line 1007 "hlsl.y"
    {
                                TRACE("Declaration statement parsed.\n");
                            }
    break;

  case 5:

/* Line 1806 of yacc.c  */
#line 1011 "hlsl.y"
    {
                            }
    break;

  case 6:

/* Line 1806 of yacc.c  */
#line 1015 "hlsl.y"
    {
                                TRACE("Updating line information to file %s, line %u\n", debugstr_a((yyvsp[(2) - (2)].name)), (yyvsp[(1) - (2)].intval));
                                hlsl_ctx.line_no = (yyvsp[(1) - (2)].intval);
                                if (strcmp((yyvsp[(2) - (2)].name), hlsl_ctx.source_file))
                                {
                                    const char **new_array;

                                    hlsl_ctx.source_file = (yyvsp[(2) - (2)].name);
                                    new_array = d3dcompiler_realloc(hlsl_ctx.source_files,
                                            sizeof(*hlsl_ctx.source_files) * hlsl_ctx.source_files_count + 1);
                                    if (new_array)
                                    {
                                        hlsl_ctx.source_files = new_array;
                                        hlsl_ctx.source_files[hlsl_ctx.source_files_count++] = (yyvsp[(2) - (2)].name);
                                    }
                                }
                            }
    break;

  case 7:

/* Line 1806 of yacc.c  */
#line 1034 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(3) - (3)]));
                                if (!(yyvsp[(2) - (3)].list))
                                {
                                    if (!(yyvsp[(1) - (3)].type)->name)
                                    {
                                        hlsl_report_message(loc.file, loc.line, loc.col,
                                                HLSL_LEVEL_ERROR, "anonymous struct declaration with no variables");
                                    }
                                    check_type_modifiers((yyvsp[(1) - (3)].type)->modifiers, &loc);
                                }
                                (yyval.list) = declare_vars((yyvsp[(1) - (3)].type), 0, (yyvsp[(2) - (3)].list));
                            }
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 1054 "hlsl.y"
    {
                                BOOL ret;
                                struct source_location loc;

                                TRACE("Structure %s declaration.\n", debugstr_a((yyvsp[(3) - (6)].name)));
                                set_location(&loc, &(yylsp[(1) - (6)]));
                                check_invalid_matrix_modifiers((yyvsp[(1) - (6)].modifiers), &loc);
                                (yyval.type) = new_struct_type((yyvsp[(3) - (6)].name), (yyvsp[(1) - (6)].modifiers), (yyvsp[(5) - (6)].list));

                                if (get_variable(hlsl_ctx.cur_scope, (yyvsp[(3) - (6)].name)))
                                {
                                    hlsl_report_message(hlsl_ctx.source_file, (yylsp[(3) - (6)]).first_line, (yylsp[(3) - (6)]).first_column,
                                            HLSL_LEVEL_ERROR, "redefinition of '%s'", (yyvsp[(3) - (6)].name));
                                    return 1;
                                }

                                ret = add_type_to_scope(hlsl_ctx.cur_scope, (yyval.type));
                                if (!ret)
                                {
                                    hlsl_report_message(hlsl_ctx.source_file, (yylsp[(3) - (6)]).first_line, (yylsp[(3) - (6)]).first_column,
                                            HLSL_LEVEL_ERROR, "redefinition of struct '%s'", (yyvsp[(3) - (6)].name));
                                    return 1;
                                }
                            }
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 1080 "hlsl.y"
    {
                                struct source_location loc;

                                TRACE("Anonymous structure declaration.\n");
                                set_location(&loc, &(yylsp[(1) - (5)]));
                                check_invalid_matrix_modifiers((yyvsp[(1) - (5)].modifiers), &loc);
                                (yyval.type) = new_struct_type(NULL, (yyvsp[(1) - (5)].modifiers), (yyvsp[(4) - (5)].list));
                            }
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 1094 "hlsl.y"
    {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                            }
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 1099 "hlsl.y"
    {
                                BOOL ret;
                                struct hlsl_struct_field *field, *next;

                                (yyval.list) = (yyvsp[(1) - (2)].list);
                                LIST_FOR_EACH_ENTRY_SAFE(field, next, (yyvsp[(2) - (2)].list), struct hlsl_struct_field, entry)
                                {
                                    ret = add_struct_field((yyval.list), field);
                                    if (ret == FALSE)
                                    {
                                        hlsl_report_message(hlsl_ctx.source_file, (yylsp[(2) - (2)]).first_line, (yylsp[(2) - (2)]).first_column,
                                                HLSL_LEVEL_ERROR, "redefinition of '%s'", field->name);
                                        d3dcompiler_free(field);
                                    }
                                }
                                d3dcompiler_free((yyvsp[(2) - (2)].list));
                            }
    break;

  case 17:

/* Line 1806 of yacc.c  */
#line 1118 "hlsl.y"
    {
                                (yyval.list) = gen_struct_fields((yyvsp[(2) - (4)].type), (yyvsp[(1) - (4)].modifiers), (yyvsp[(3) - (4)].list));
                            }
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 1122 "hlsl.y"
    {
                                (yyval.list) = gen_struct_fields((yyvsp[(1) - (3)].type), 0, (yyvsp[(2) - (3)].list));
                            }
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 1127 "hlsl.y"
    {
                                TRACE("Function %s parsed.\n", (yyvsp[(1) - (2)].function)->name);
                                (yyval.function) = (yyvsp[(1) - (2)].function);
                                (yyval.function)->body = (yyvsp[(2) - (2)].list);
                                pop_scope(&hlsl_ctx);
                            }
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 1134 "hlsl.y"
    {
                                TRACE("Function prototype for %s.\n", (yyvsp[(1) - (2)].function)->name);
                                (yyval.function) = (yyvsp[(1) - (2)].function);
                                pop_scope(&hlsl_ctx);
                            }
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 1141 "hlsl.y"
    {
                                if (get_variable(hlsl_ctx.globals, (yyvsp[(3) - (7)].name)))
                                {
                                    hlsl_report_message(hlsl_ctx.source_file, (yylsp[(3) - (7)]).first_line, (yylsp[(3) - (7)]).first_column,
                                            HLSL_LEVEL_ERROR, "redefinition of '%s'\n", (yyvsp[(3) - (7)].name));
                                    return 1;
                                }
                                if ((yyvsp[(2) - (7)].type)->base_type == HLSL_TYPE_VOID && (yyvsp[(7) - (7)].name))
                                {
                                    hlsl_report_message(hlsl_ctx.source_file, (yylsp[(7) - (7)]).first_line, (yylsp[(7) - (7)]).first_column,
                                            HLSL_LEVEL_ERROR, "void function with a semantic");
                                }

                                (yyval.function) = new_func_decl((yyvsp[(3) - (7)].name), (yyvsp[(2) - (7)].type), (yyvsp[(5) - (7)].list));
                                if (!(yyval.function))
                                {
                                    ERR("Out of memory.\n");
                                    return -1;
                                }
                                (yyval.function)->semantic = (yyvsp[(7) - (7)].name);
                            }
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 1164 "hlsl.y"
    {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                            }
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 1169 "hlsl.y"
    {
                                pop_scope(&hlsl_ctx);
                                (yyval.list) = (yyvsp[(3) - (4)].list);
                            }
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 1175 "hlsl.y"
    {
                                push_scope(&hlsl_ctx);
                            }
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 1183 "hlsl.y"
    {
                                (yyval.name) = NULL;
                            }
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 1187 "hlsl.y"
    {
                                (yyval.name) = (yyvsp[(2) - (2)].name);
                            }
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 1192 "hlsl.y"
    {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                            }
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 1197 "hlsl.y"
    {
                                (yyval.list) = (yyvsp[(2) - (2)].list);
                            }
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 1202 "hlsl.y"
    {
                                struct source_location loc;

                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                set_location(&loc, &(yylsp[(1) - (1)]));
                                if (!add_func_parameter((yyval.list), &(yyvsp[(1) - (1)].parameter), &loc))
                                {
                                    ERR("Error adding function parameter %s.\n", (yyvsp[(1) - (1)].parameter).name);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    return -1;
                                }
                            }
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 1216 "hlsl.y"
    {
                                struct source_location loc;

                                (yyval.list) = (yyvsp[(1) - (3)].list);
                                set_location(&loc, &(yylsp[(3) - (3)]));
                                if (!add_func_parameter((yyval.list), &(yyvsp[(3) - (3)].parameter), &loc))
                                {
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                            "duplicate parameter %s", (yyvsp[(3) - (3)].parameter).name);
                                    return 1;
                                }
                            }
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 1230 "hlsl.y"
    {
                                (yyval.parameter).modifiers = (yyvsp[(1) - (5)].modifiers);
                                (yyval.parameter).modifiers |= (yyvsp[(2) - (5)].modifiers);
                                (yyval.parameter).type = (yyvsp[(3) - (5)].type);
                                (yyval.parameter).name = (yyvsp[(4) - (5)].name);
                                (yyval.parameter).semantic = (yyvsp[(5) - (5)].name);
                            }
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 1239 "hlsl.y"
    {
                                (yyval.modifiers) = HLSL_MODIFIER_IN;
                            }
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 1243 "hlsl.y"
    {
                                (yyval.modifiers) = HLSL_MODIFIER_IN;
                            }
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 1247 "hlsl.y"
    {
                                (yyval.modifiers) = HLSL_MODIFIER_OUT;
                            }
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 1251 "hlsl.y"
    {
                                (yyval.modifiers) = HLSL_MODIFIER_IN | HLSL_MODIFIER_OUT;
                            }
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 1256 "hlsl.y"
    {
                                (yyval.type) = (yyvsp[(1) - (1)].type);
                            }
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 1260 "hlsl.y"
    {
                                if ((yyvsp[(3) - (6)].type)->type != HLSL_CLASS_SCALAR)
                                {
                                    hlsl_message("Line %u: vectors of non-scalar types are not allowed.\n",
                                            hlsl_ctx.line_no);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    return 1;
                                }
                                if ((yyvsp[(5) - (6)].intval) < 1 || (yyvsp[(5) - (6)].intval) > 4)
                                {
                                    hlsl_message("Line %u: vector size must be between 1 and 4.\n",
                                            hlsl_ctx.line_no);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    return 1;
                                }

                                (yyval.type) = new_hlsl_type(NULL, HLSL_CLASS_VECTOR, (yyvsp[(3) - (6)].type)->base_type, (yyvsp[(5) - (6)].intval), 1);
                            }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 1279 "hlsl.y"
    {
                                if ((yyvsp[(3) - (8)].type)->type != HLSL_CLASS_SCALAR)
                                {
                                    hlsl_message("Line %u: matrices of non-scalar types are not allowed.\n",
                                            hlsl_ctx.line_no);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    return 1;
                                }
                                if ((yyvsp[(5) - (8)].intval) < 1 || (yyvsp[(5) - (8)].intval) > 4 || (yyvsp[(7) - (8)].intval) < 1 || (yyvsp[(7) - (8)].intval) > 4)
                                {
                                    hlsl_message("Line %u: matrix dimensions must be between 1 and 4.\n",
                                            hlsl_ctx.line_no);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    return 1;
                                }

                                (yyval.type) = new_hlsl_type(NULL, HLSL_CLASS_MATRIX, (yyvsp[(3) - (8)].type)->base_type, (yyvsp[(5) - (8)].intval), (yyvsp[(7) - (8)].intval));
                            }
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 1299 "hlsl.y"
    {
                                (yyval.type) = new_hlsl_type(d3dcompiler_strdup("void"), HLSL_CLASS_OBJECT, HLSL_TYPE_VOID, 1, 1);
                            }
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 1303 "hlsl.y"
    {
                                (yyval.type) = new_hlsl_type(d3dcompiler_strdup("sampler"), HLSL_CLASS_OBJECT, HLSL_TYPE_SAMPLER, 1, 1);
                                (yyval.type)->sampler_dim = HLSL_SAMPLER_DIM_GENERIC;
                            }
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 1308 "hlsl.y"
    {
                                (yyval.type) = new_hlsl_type(d3dcompiler_strdup("sampler1D"), HLSL_CLASS_OBJECT, HLSL_TYPE_SAMPLER, 1, 1);
                                (yyval.type)->sampler_dim = HLSL_SAMPLER_DIM_1D;
                            }
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 1313 "hlsl.y"
    {
                                (yyval.type) = new_hlsl_type(d3dcompiler_strdup("sampler2D"), HLSL_CLASS_OBJECT, HLSL_TYPE_SAMPLER, 1, 1);
                                (yyval.type)->sampler_dim = HLSL_SAMPLER_DIM_2D;
                            }
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 1318 "hlsl.y"
    {
                                (yyval.type) = new_hlsl_type(d3dcompiler_strdup("sampler3D"), HLSL_CLASS_OBJECT, HLSL_TYPE_SAMPLER, 1, 1);
                                (yyval.type)->sampler_dim = HLSL_SAMPLER_DIM_3D;
                            }
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 1323 "hlsl.y"
    {
                                (yyval.type) = new_hlsl_type(d3dcompiler_strdup("samplerCUBE"), HLSL_CLASS_OBJECT, HLSL_TYPE_SAMPLER, 1, 1);
                                (yyval.type)->sampler_dim = HLSL_SAMPLER_DIM_CUBE;
                            }
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 1328 "hlsl.y"
    {
                                struct hlsl_type *type;

                                TRACE("Type %s.\n", (yyvsp[(1) - (1)].name));
                                type = get_type(hlsl_ctx.cur_scope, (yyvsp[(1) - (1)].name), TRUE);
                                (yyval.type) = type;
                                d3dcompiler_free((yyvsp[(1) - (1)].name));
                            }
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 1337 "hlsl.y"
    {
                                struct hlsl_type *type;

                                TRACE("Struct type %s.\n", (yyvsp[(2) - (2)].name));
                                type = get_type(hlsl_ctx.cur_scope, (yyvsp[(2) - (2)].name), TRUE);
                                if (type->type != HLSL_CLASS_STRUCT)
                                {
                                    hlsl_message("Line %u: redefining %s as a structure.\n",
                                            hlsl_ctx.line_no, (yyvsp[(2) - (2)].name));
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                }
                                else
                                {
                                    (yyval.type) = type;
                                }
                                d3dcompiler_free((yyvsp[(2) - (2)].name));
                            }
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 1358 "hlsl.y"
    {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                if (!(yyval.list))
                                {
                                    ERR("Out of memory\n");
                                    return -1;
                                }
                                list_init((yyval.list));
                            }
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 1369 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(1) - (5)]));
                                if (!add_typedef((yyvsp[(2) - (5)].modifiers), (yyvsp[(3) - (5)].type), (yyvsp[(4) - (5)].list), &loc))
                                    return 1;
                            }
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 1377 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(1) - (4)]));
                                if (!add_typedef(0, (yyvsp[(2) - (4)].type), (yyvsp[(3) - (4)].list), &loc))
                                    return 1;
                            }
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 1386 "hlsl.y"
    {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                list_add_head((yyval.list), &(yyvsp[(1) - (1)].variable_def)->entry);
                            }
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 1392 "hlsl.y"
    {
                                (yyval.list) = (yyvsp[(1) - (3)].list);
                                list_add_tail((yyval.list), &(yyvsp[(3) - (3)].variable_def)->entry);
                            }
    break;

  case 56:

/* Line 1806 of yacc.c  */
#line 1398 "hlsl.y"
    {
                                (yyval.variable_def) = d3dcompiler_alloc(sizeof(*(yyval.variable_def)));
                                set_location(&(yyval.variable_def)->loc, &(yylsp[(1) - (2)]));
                                (yyval.variable_def)->name = (yyvsp[(1) - (2)].name);
                                (yyval.variable_def)->array_size = (yyvsp[(2) - (2)].intval);
                            }
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 1406 "hlsl.y"
    {
                                (yyval.list) = declare_vars((yyvsp[(2) - (4)].type), (yyvsp[(1) - (4)].modifiers), (yyvsp[(3) - (4)].list));
                            }
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 1411 "hlsl.y"
    {
                                (yyval.list) = NULL;
                            }
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 1415 "hlsl.y"
    {
                                (yyval.list) = (yyvsp[(1) - (1)].list);
                            }
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 1420 "hlsl.y"
    {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                list_add_head((yyval.list), &(yyvsp[(1) - (1)].variable_def)->entry);
                            }
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 1426 "hlsl.y"
    {
                                (yyval.list) = (yyvsp[(1) - (3)].list);
                                list_add_tail((yyval.list), &(yyvsp[(3) - (3)].variable_def)->entry);
                            }
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 1432 "hlsl.y"
    {
                                (yyval.variable_def) = d3dcompiler_alloc(sizeof(*(yyval.variable_def)));
                                set_location(&(yyval.variable_def)->loc, &(yylsp[(1) - (3)]));
                                (yyval.variable_def)->name = (yyvsp[(1) - (3)].name);
                                (yyval.variable_def)->array_size = (yyvsp[(2) - (3)].intval);
                                (yyval.variable_def)->semantic = (yyvsp[(3) - (3)].name);
                            }
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 1440 "hlsl.y"
    {
                                TRACE("Declaration with initializer.\n");
                                (yyval.variable_def) = d3dcompiler_alloc(sizeof(*(yyval.variable_def)));
                                set_location(&(yyval.variable_def)->loc, &(yylsp[(1) - (5)]));
                                (yyval.variable_def)->name = (yyvsp[(1) - (5)].name);
                                (yyval.variable_def)->array_size = (yyvsp[(2) - (5)].intval);
                                (yyval.variable_def)->semantic = (yyvsp[(3) - (5)].name);
                                (yyval.variable_def)->initializer = (yyvsp[(5) - (5)].list);
                            }
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 1451 "hlsl.y"
    {
                                (yyval.intval) = 0;
                            }
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 1455 "hlsl.y"
    {
                                FIXME("Array.\n");
                                (yyval.intval) = 0;
                                free_instr((yyvsp[(2) - (3)].instr));
                            }
    break;

  case 66:

/* Line 1806 of yacc.c  */
#line 1462 "hlsl.y"
    {
                                (yyval.modifiers) = 0;
                            }
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 1466 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_STORAGE_EXTERN, &(yylsp[(1) - (2)]));
                            }
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 1470 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_STORAGE_NOINTERPOLATION, &(yylsp[(1) - (2)]));
                            }
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 1474 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_MODIFIER_PRECISE, &(yylsp[(1) - (2)]));
                            }
    break;

  case 70:

/* Line 1806 of yacc.c  */
#line 1478 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_STORAGE_SHARED, &(yylsp[(1) - (2)]));
                            }
    break;

  case 71:

/* Line 1806 of yacc.c  */
#line 1482 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_STORAGE_GROUPSHARED, &(yylsp[(1) - (2)]));
                            }
    break;

  case 72:

/* Line 1806 of yacc.c  */
#line 1486 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_STORAGE_STATIC, &(yylsp[(1) - (2)]));
                            }
    break;

  case 73:

/* Line 1806 of yacc.c  */
#line 1490 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_STORAGE_UNIFORM, &(yylsp[(1) - (2)]));
                            }
    break;

  case 74:

/* Line 1806 of yacc.c  */
#line 1494 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_STORAGE_VOLATILE, &(yylsp[(1) - (2)]));
                            }
    break;

  case 75:

/* Line 1806 of yacc.c  */
#line 1498 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_MODIFIER_CONST, &(yylsp[(1) - (2)]));
                            }
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 1502 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_MODIFIER_ROW_MAJOR, &(yylsp[(1) - (2)]));
                            }
    break;

  case 77:

/* Line 1806 of yacc.c  */
#line 1506 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_MODIFIER_COLUMN_MAJOR, &(yylsp[(1) - (2)]));
                            }
    break;

  case 78:

/* Line 1806 of yacc.c  */
#line 1511 "hlsl.y"
    {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                list_add_head((yyval.list), &(yyvsp[(1) - (1)].instr)->entry);
                            }
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 1517 "hlsl.y"
    {
                                (yyval.list) = (yyvsp[(2) - (3)].list);
                            }
    break;

  case 80:

/* Line 1806 of yacc.c  */
#line 1522 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            }
    break;

  case 81:

/* Line 1806 of yacc.c  */
#line 1527 "hlsl.y"
    {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                list_add_head((yyval.list), &(yyvsp[(1) - (1)].instr)->entry);
                            }
    break;

  case 82:

/* Line 1806 of yacc.c  */
#line 1533 "hlsl.y"
    {
                                (yyval.list) = (yyvsp[(1) - (3)].list);
                                list_add_tail((yyval.list), &(yyvsp[(3) - (3)].instr)->entry);
                            }
    break;

  case 83:

/* Line 1806 of yacc.c  */
#line 1539 "hlsl.y"
    {
                                (yyval.boolval) = TRUE;
                            }
    break;

  case 84:

/* Line 1806 of yacc.c  */
#line 1543 "hlsl.y"
    {
                                (yyval.boolval) = FALSE;
                            }
    break;

  case 85:

/* Line 1806 of yacc.c  */
#line 1548 "hlsl.y"
    {
                                (yyval.list) = (yyvsp[(1) - (1)].list);
                            }
    break;

  case 86:

/* Line 1806 of yacc.c  */
#line 1552 "hlsl.y"
    {
                                (yyval.list) = (yyvsp[(1) - (2)].list);
                                list_move_tail((yyval.list), (yyvsp[(2) - (2)].list));
                                d3dcompiler_free((yyvsp[(2) - (2)].list));
                            }
    break;

  case 93:

/* Line 1806 of yacc.c  */
#line 1567 "hlsl.y"
    {
                                struct hlsl_ir_jump *jump = d3dcompiler_alloc(sizeof(*jump));
                                if (!jump)
                                {
                                    ERR("Out of memory\n");
                                    return -1;
                                }
                                jump->node.type = HLSL_IR_JUMP;
                                set_location(&jump->node.loc, &(yylsp[(1) - (3)]));
                                jump->type = HLSL_IR_JUMP_RETURN;
                                jump->node.data_type = (yyvsp[(2) - (3)].instr)->data_type;
                                jump->return_value = (yyvsp[(2) - (3)].instr);

                                FIXME("Check for valued return on void function.\n");
                                FIXME("Implicit conversion to the return type if needed, "
				        "error out if conversion not possible.\n");

                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                list_add_tail((yyval.list), &jump->node.entry);
                            }
    break;

  case 94:

/* Line 1806 of yacc.c  */
#line 1590 "hlsl.y"
    {
                                struct hlsl_ir_if *instr = d3dcompiler_alloc(sizeof(*instr));
                                if (!instr)
                                {
                                    ERR("Out of memory\n");
                                    return -1;
                                }
                                instr->node.type = HLSL_IR_IF;
                                set_location(&instr->node.loc, &(yylsp[(1) - (5)]));
                                instr->condition = (yyvsp[(3) - (5)].instr);
                                instr->then_instrs = (yyvsp[(5) - (5)].if_body).then_instrs;
                                instr->else_instrs = (yyvsp[(5) - (5)].if_body).else_instrs;
                                if ((yyvsp[(3) - (5)].instr)->data_type->dimx > 1 || (yyvsp[(3) - (5)].instr)->data_type->dimy > 1)
                                {
                                    hlsl_report_message(instr->node.loc.file, instr->node.loc.line,
                                            instr->node.loc.col, HLSL_LEVEL_ERROR,
                                            "if condition requires a scalar");
                                }
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                list_add_head((yyval.list), &instr->node.entry);
                            }
    break;

  case 95:

/* Line 1806 of yacc.c  */
#line 1614 "hlsl.y"
    {
                                (yyval.if_body).then_instrs = (yyvsp[(1) - (1)].list);
                                (yyval.if_body).else_instrs = NULL;
                            }
    break;

  case 96:

/* Line 1806 of yacc.c  */
#line 1619 "hlsl.y"
    {
                                (yyval.if_body).then_instrs = (yyvsp[(1) - (3)].list);
                                (yyval.if_body).else_instrs = (yyvsp[(3) - (3)].list);
                            }
    break;

  case 97:

/* Line 1806 of yacc.c  */
#line 1625 "hlsl.y"
    {
                                struct source_location loc;
                                struct list *cond = d3dcompiler_alloc(sizeof(*cond));

                                if (!cond)
                                {
                                    ERR("Out of memory.\n");
                                    return -1;
                                }
                                list_init(cond);
                                list_add_head(cond, &(yyvsp[(3) - (5)].instr)->entry);
                                set_location(&loc, &(yylsp[(1) - (5)]));
                                (yyval.list) = create_loop(LOOP_WHILE, NULL, cond, NULL, (yyvsp[(5) - (5)].list), &loc);
                            }
    break;

  case 98:

/* Line 1806 of yacc.c  */
#line 1640 "hlsl.y"
    {
                                struct source_location loc;
                                struct list *cond = d3dcompiler_alloc(sizeof(*cond));

                                if (!cond)
                                {
                                    ERR("Out of memory.\n");
                                    return -1;
                                }
                                list_init(cond);
                                list_add_head(cond, &(yyvsp[(5) - (7)].instr)->entry);
                                set_location(&loc, &(yylsp[(1) - (7)]));
                                (yyval.list) = create_loop(LOOP_DO_WHILE, NULL, cond, NULL, (yyvsp[(2) - (7)].list), &loc);
                            }
    break;

  case 99:

/* Line 1806 of yacc.c  */
#line 1655 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(1) - (8)]));
                                (yyval.list) = create_loop(LOOP_FOR, (yyvsp[(4) - (8)].list), (yyvsp[(5) - (8)].list), (yyvsp[(6) - (8)].list), (yyvsp[(8) - (8)].list), &loc);
                                pop_scope(&hlsl_ctx);
                            }
    break;

  case 100:

/* Line 1806 of yacc.c  */
#line 1663 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(1) - (8)]));
                                if (!(yyvsp[(4) - (8)].list))
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_WARNING,
                                            "no expressions in for loop initializer");
                                (yyval.list) = create_loop(LOOP_FOR, (yyvsp[(4) - (8)].list), (yyvsp[(5) - (8)].list), (yyvsp[(6) - (8)].list), (yyvsp[(8) - (8)].list), &loc);
                                pop_scope(&hlsl_ctx);
                            }
    break;

  case 101:

/* Line 1806 of yacc.c  */
#line 1675 "hlsl.y"
    {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                            }
    break;

  case 102:

/* Line 1806 of yacc.c  */
#line 1680 "hlsl.y"
    {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                if ((yyvsp[(1) - (2)].instr))
                                    list_add_head((yyval.list), &(yyvsp[(1) - (2)].instr)->entry);
                            }
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 1688 "hlsl.y"
    {
                                struct hlsl_ir_constant *c = d3dcompiler_alloc(sizeof(*c));
                                if (!c)
                                {
                                    ERR("Out of memory.\n");
                                    return -1;
                                }
                                c->node.type = HLSL_IR_CONSTANT;
                                set_location(&c->node.loc, &yylloc);
                                c->node.data_type = new_hlsl_type("float", HLSL_CLASS_SCALAR, HLSL_TYPE_FLOAT, 1, 1);
                                c->v.value.f[0] = (yyvsp[(1) - (1)].floatval);
                                (yyval.instr) = &c->node;
                            }
    break;

  case 104:

/* Line 1806 of yacc.c  */
#line 1702 "hlsl.y"
    {
                                struct hlsl_ir_constant *c = d3dcompiler_alloc(sizeof(*c));
                                if (!c)
                                {
                                    ERR("Out of memory.\n");
                                    return -1;
                                }
                                c->node.type = HLSL_IR_CONSTANT;
                                set_location(&c->node.loc, &yylloc);
                                c->node.data_type = new_hlsl_type("int", HLSL_CLASS_SCALAR, HLSL_TYPE_INT, 1, 1);
                                c->v.value.i[0] = (yyvsp[(1) - (1)].intval);
                                (yyval.instr) = &c->node;
                            }
    break;

  case 105:

/* Line 1806 of yacc.c  */
#line 1716 "hlsl.y"
    {
                                struct hlsl_ir_constant *c = d3dcompiler_alloc(sizeof(*c));
                                if (!c)
                                {
                                    ERR("Out of memory.\n");
                                    return -1;
                                }
                                c->node.type = HLSL_IR_CONSTANT;
                                set_location(&c->node.loc, &yylloc);
                                c->node.data_type = new_hlsl_type("bool", HLSL_CLASS_SCALAR, HLSL_TYPE_BOOL, 1, 1);
                                c->v.value.b[0] = (yyvsp[(1) - (1)].boolval);
                                (yyval.instr) = &c->node;
                            }
    break;

  case 106:

/* Line 1806 of yacc.c  */
#line 1730 "hlsl.y"
    {
                                struct hlsl_ir_deref *deref = new_var_deref((yyvsp[(1) - (1)].var));
                                if (deref)
                                {
                                    (yyval.instr) = &deref->node;
                                    set_location(&(yyval.instr)->loc, &(yylsp[(1) - (1)]));
                                }
                                else
                                    (yyval.instr) = NULL;
                            }
    break;

  case 107:

/* Line 1806 of yacc.c  */
#line 1741 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(2) - (3)].instr);
                            }
    break;

  case 108:

/* Line 1806 of yacc.c  */
#line 1746 "hlsl.y"
    {
                                struct hlsl_ir_var *var;
                                var = get_variable(hlsl_ctx.cur_scope, (yyvsp[(1) - (1)].name));
                                if (!var)
                                {
                                    hlsl_message("Line %d: variable '%s' not declared\n",
                                            hlsl_ctx.line_no, (yyvsp[(1) - (1)].name));
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    return 1;
                                }
                                (yyval.var) = var;
                            }
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 1760 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            }
    break;

  case 110:

/* Line 1806 of yacc.c  */
#line 1764 "hlsl.y"
    {
                                struct hlsl_ir_node *operands[3];
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (2)]));
                                if ((yyvsp[(1) - (2)].instr)->data_type->modifiers & HLSL_MODIFIER_CONST)
                                {
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                            "modifying a const expression");
                                    return 1;
                                }
                                operands[0] = (yyvsp[(1) - (2)].instr);
                                operands[1] = operands[2] = NULL;
                                (yyval.instr) = &new_expr(HLSL_IR_BINOP_POSTINC, operands, &loc)->node;
                                /* Post increment/decrement expressions are considered const */
                                (yyval.instr)->data_type = clone_hlsl_type((yyval.instr)->data_type);
                                (yyval.instr)->data_type->modifiers |= HLSL_MODIFIER_CONST;
                            }
    break;

  case 111:

/* Line 1806 of yacc.c  */
#line 1783 "hlsl.y"
    {
                                struct hlsl_ir_node *operands[3];
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (2)]));
                                if ((yyvsp[(1) - (2)].instr)->data_type->modifiers & HLSL_MODIFIER_CONST)
                                {
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                            "modifying a const expression");
                                    return 1;
                                }
                                operands[0] = (yyvsp[(1) - (2)].instr);
                                operands[1] = operands[2] = NULL;
                                (yyval.instr) = &new_expr(HLSL_IR_BINOP_POSTDEC, operands, &loc)->node;
                                /* Post increment/decrement expressions are considered const */
                                (yyval.instr)->data_type = clone_hlsl_type((yyval.instr)->data_type);
                                (yyval.instr)->data_type->modifiers |= HLSL_MODIFIER_CONST;
                            }
    break;

  case 112:

/* Line 1806 of yacc.c  */
#line 1802 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                if ((yyvsp[(1) - (3)].instr)->data_type->type == HLSL_CLASS_STRUCT)
                                {
                                    struct hlsl_type *type = (yyvsp[(1) - (3)].instr)->data_type;
                                    struct hlsl_struct_field *field;

                                    (yyval.instr) = NULL;
                                    LIST_FOR_EACH_ENTRY(field, type->e.elements, struct hlsl_struct_field, entry)
                                    {
                                        if (!strcmp((yyvsp[(3) - (3)].name), field->name))
                                        {
                                            struct hlsl_ir_deref *deref = new_record_deref((yyvsp[(1) - (3)].instr), field);

                                            if (!deref)
                                            {
                                                ERR("Out of memory\n");
                                                return -1;
                                            }
                                            deref->node.loc = loc;
                                            (yyval.instr) = &deref->node;
                                            break;
                                        }
                                    }
                                    if (!(yyval.instr))
                                    {
                                        hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                                "invalid subscript %s", debugstr_a((yyvsp[(3) - (3)].name)));
                                        return 1;
                                    }
                                }
                                else if ((yyvsp[(1) - (3)].instr)->data_type->type <= HLSL_CLASS_LAST_NUMERIC)
                                {
                                    struct hlsl_ir_swizzle *swizzle;

                                    swizzle = get_swizzle((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].name), &loc);
                                    if (!swizzle)
                                    {
                                        hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                                "invalid swizzle %s", debugstr_a((yyvsp[(3) - (3)].name)));
                                        return 1;
                                    }
                                    (yyval.instr) = &swizzle->node;
                                }
                                else
                                {
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                            "invalid subscript %s", debugstr_a((yyvsp[(3) - (3)].name)));
                                    return 1;
                                }
                            }
    break;

  case 113:

/* Line 1806 of yacc.c  */
#line 1856 "hlsl.y"
    {
                                /* This may be an array dereference or a vector/matrix
                                 * subcomponent access.
                                 * We store it as an array dereference in any case. */
                                struct hlsl_ir_deref *deref = d3dcompiler_alloc(sizeof(*deref));
                                struct hlsl_type *expr_type = (yyvsp[(1) - (4)].instr)->data_type;
                                struct source_location loc;

                                TRACE("Array dereference from type %s\n", debug_hlsl_type(expr_type));
                                if (!deref)
                                {
                                    ERR("Out of memory\n");
                                    return -1;
                                }
                                deref->node.type = HLSL_IR_DEREF;
                                set_location(&loc, &(yylsp[(2) - (4)]));
                                deref->node.loc = loc;
                                if (expr_type->type == HLSL_CLASS_ARRAY)
                                {
                                    deref->node.data_type = expr_type->e.array.type;
                                }
                                else if (expr_type->type == HLSL_CLASS_MATRIX)
                                {
                                    deref->node.data_type = new_hlsl_type(NULL, HLSL_CLASS_VECTOR, expr_type->base_type, expr_type->dimx, 1);
                                }
                                else if (expr_type->type == HLSL_CLASS_VECTOR)
                                {
                                    deref->node.data_type = new_hlsl_type(NULL, HLSL_CLASS_SCALAR, expr_type->base_type, 1, 1);
                                }
                                else
                                {
                                    if (expr_type->type == HLSL_CLASS_SCALAR)
                                        hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                                "array-indexed expression is scalar");
                                    else
                                        hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                                "expression is not array-indexable");
                                    d3dcompiler_free(deref);
                                    free_instr((yyvsp[(1) - (4)].instr));
                                    free_instr((yyvsp[(3) - (4)].instr));
                                    return 1;
                                }
                                if ((yyvsp[(3) - (4)].instr)->data_type->type != HLSL_CLASS_SCALAR)
                                {
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                            "array index is not scalar");
                                    d3dcompiler_free(deref);
                                    free_instr((yyvsp[(1) - (4)].instr));
                                    free_instr((yyvsp[(3) - (4)].instr));
                                    return 1;
                                }
                                deref->type = HLSL_IR_DEREF_ARRAY;
                                deref->v.array.array = (yyvsp[(1) - (4)].instr);
                                deref->v.array.index = (yyvsp[(3) - (4)].instr);

                                (yyval.instr) = &deref->node;
                            }
    break;

  case 114:

/* Line 1806 of yacc.c  */
#line 1916 "hlsl.y"
    {
                                struct hlsl_ir_constructor *constructor;

                                TRACE("%s constructor.\n", debug_hlsl_type((yyvsp[(2) - (5)].type)));
                                if ((yyvsp[(1) - (5)].modifiers))
                                {
                                    hlsl_message("Line %u: unexpected modifier in a constructor.\n",
                                            hlsl_ctx.line_no);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    return -1;
                                }
                                if ((yyvsp[(2) - (5)].type)->type > HLSL_CLASS_LAST_NUMERIC)
                                {
                                    hlsl_message("Line %u: constructors are allowed only for numeric data types.\n",
                                            hlsl_ctx.line_no);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    return -1;
                                }
                                if ((yyvsp[(2) - (5)].type)->dimx * (yyvsp[(2) - (5)].type)->dimy != components_count_expr_list((yyvsp[(4) - (5)].list)))
                                {
                                    hlsl_message("Line %u: wrong number of components in constructor.\n",
                                            hlsl_ctx.line_no);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    return -1;
                                }

                                constructor = d3dcompiler_alloc(sizeof(*constructor));
                                constructor->node.type = HLSL_IR_CONSTRUCTOR;
                                set_location(&constructor->node.loc, &(yylsp[(3) - (5)]));
                                constructor->node.data_type = (yyvsp[(2) - (5)].type);
                                constructor->arguments = (yyvsp[(4) - (5)].list);

                                (yyval.instr) = &constructor->node;
                            }
    break;

  case 115:

/* Line 1806 of yacc.c  */
#line 1952 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            }
    break;

  case 116:

/* Line 1806 of yacc.c  */
#line 1956 "hlsl.y"
    {
                                struct hlsl_ir_node *operands[3];
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(1) - (2)]));
                                if ((yyvsp[(2) - (2)].instr)->data_type->modifiers & HLSL_MODIFIER_CONST)
                                {
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                            "modifying a const expression");
                                    return 1;
                                }
                                operands[0] = (yyvsp[(2) - (2)].instr);
                                operands[1] = operands[2] = NULL;
                                (yyval.instr) = &new_expr(HLSL_IR_BINOP_PREINC, operands, &loc)->node;
                            }
    break;

  case 117:

/* Line 1806 of yacc.c  */
#line 1972 "hlsl.y"
    {
                                struct hlsl_ir_node *operands[3];
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(1) - (2)]));
                                if ((yyvsp[(2) - (2)].instr)->data_type->modifiers & HLSL_MODIFIER_CONST)
                                {
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                            "modifying a const expression");
                                    return 1;
                                }
                                operands[0] = (yyvsp[(2) - (2)].instr);
                                operands[1] = operands[2] = NULL;
                                (yyval.instr) = &new_expr(HLSL_IR_BINOP_PREDEC, operands, &loc)->node;
                            }
    break;

  case 118:

/* Line 1806 of yacc.c  */
#line 1988 "hlsl.y"
    {
                                enum hlsl_ir_expr_op ops[] = {0, HLSL_IR_UNOP_NEG,
                                        HLSL_IR_UNOP_LOGIC_NOT, HLSL_IR_UNOP_BIT_NOT};
                                struct hlsl_ir_node *operands[3];
                                struct source_location loc;

                                if ((yyvsp[(1) - (2)].unary_op) == UNARY_OP_PLUS)
                                {
                                    (yyval.instr) = (yyvsp[(2) - (2)].instr);
                                }
                                else
                                {
                                    operands[0] = (yyvsp[(2) - (2)].instr);
                                    operands[1] = operands[2] = NULL;
                                    set_location(&loc, &(yylsp[(1) - (2)]));
                                    (yyval.instr) = &new_expr(ops[(yyvsp[(1) - (2)].unary_op)], operands, &loc)->node;
                                }
                            }
    break;

  case 119:

/* Line 1806 of yacc.c  */
#line 2008 "hlsl.y"
    {
                                struct hlsl_ir_expr *expr;
                                struct hlsl_type *src_type = (yyvsp[(6) - (6)].instr)->data_type;
                                struct hlsl_type *dst_type;
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(3) - (6)]));
                                if ((yyvsp[(2) - (6)].modifiers))
                                {
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                            "unexpected modifier in a cast");
                                    return 1;
                                }

                                if ((yyvsp[(4) - (6)].intval))
                                    dst_type = new_array_type((yyvsp[(3) - (6)].type), (yyvsp[(4) - (6)].intval));
                                else
                                    dst_type = (yyvsp[(3) - (6)].type);

                                if (!compatible_data_types(src_type, dst_type))
                                {
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                            "can't cast from %s to %s",
                                            debug_hlsl_type(src_type), debug_hlsl_type(dst_type));
                                    return 1;
                                }

                                expr = new_cast((yyvsp[(6) - (6)].instr), dst_type, &loc);
                                (yyval.instr) = expr ? &expr->node : NULL;
                            }
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 2040 "hlsl.y"
    {
                                (yyval.unary_op) = UNARY_OP_PLUS;
                            }
    break;

  case 121:

/* Line 1806 of yacc.c  */
#line 2044 "hlsl.y"
    {
                                (yyval.unary_op) = UNARY_OP_MINUS;
                            }
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 2048 "hlsl.y"
    {
                                (yyval.unary_op) = UNARY_OP_LOGICNOT;
                            }
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 2052 "hlsl.y"
    {
                                (yyval.unary_op) = UNARY_OP_BITNOT;
                            }
    break;

  case 124:

/* Line 1806 of yacc.c  */
#line 2057 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            }
    break;

  case 125:

/* Line 1806 of yacc.c  */
#line 2061 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_mul((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            }
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 2068 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_div((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            }
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 2075 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_mod((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            }
    break;

  case 128:

/* Line 1806 of yacc.c  */
#line 2083 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            }
    break;

  case 129:

/* Line 1806 of yacc.c  */
#line 2087 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_add((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            }
    break;

  case 130:

/* Line 1806 of yacc.c  */
#line 2094 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_sub((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            }
    break;

  case 131:

/* Line 1806 of yacc.c  */
#line 2102 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            }
    break;

  case 132:

/* Line 1806 of yacc.c  */
#line 2106 "hlsl.y"
    {
                                FIXME("Left shift\n");
                            }
    break;

  case 133:

/* Line 1806 of yacc.c  */
#line 2110 "hlsl.y"
    {
                                FIXME("Right shift\n");
                            }
    break;

  case 134:

/* Line 1806 of yacc.c  */
#line 2115 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            }
    break;

  case 135:

/* Line 1806 of yacc.c  */
#line 2119 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_lt((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            }
    break;

  case 136:

/* Line 1806 of yacc.c  */
#line 2126 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_gt((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            }
    break;

  case 137:

/* Line 1806 of yacc.c  */
#line 2133 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_le((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            }
    break;

  case 138:

/* Line 1806 of yacc.c  */
#line 2140 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_ge((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            }
    break;

  case 139:

/* Line 1806 of yacc.c  */
#line 2148 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            }
    break;

  case 140:

/* Line 1806 of yacc.c  */
#line 2152 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_eq((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            }
    break;

  case 141:

/* Line 1806 of yacc.c  */
#line 2159 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_ne((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            }
    break;

  case 142:

/* Line 1806 of yacc.c  */
#line 2167 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            }
    break;

  case 143:

/* Line 1806 of yacc.c  */
#line 2171 "hlsl.y"
    {
                                FIXME("bitwise AND\n");
                            }
    break;

  case 144:

/* Line 1806 of yacc.c  */
#line 2176 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            }
    break;

  case 145:

/* Line 1806 of yacc.c  */
#line 2180 "hlsl.y"
    {
                                FIXME("bitwise XOR\n");
                            }
    break;

  case 146:

/* Line 1806 of yacc.c  */
#line 2185 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            }
    break;

  case 147:

/* Line 1806 of yacc.c  */
#line 2189 "hlsl.y"
    {
                                FIXME("bitwise OR\n");
                            }
    break;

  case 148:

/* Line 1806 of yacc.c  */
#line 2194 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            }
    break;

  case 149:

/* Line 1806 of yacc.c  */
#line 2198 "hlsl.y"
    {
                                FIXME("logic AND\n");
                            }
    break;

  case 150:

/* Line 1806 of yacc.c  */
#line 2203 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            }
    break;

  case 151:

/* Line 1806 of yacc.c  */
#line 2207 "hlsl.y"
    {
                                FIXME("logic OR\n");
                            }
    break;

  case 152:

/* Line 1806 of yacc.c  */
#line 2212 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            }
    break;

  case 153:

/* Line 1806 of yacc.c  */
#line 2216 "hlsl.y"
    {
                                FIXME("ternary operator\n");
                            }
    break;

  case 154:

/* Line 1806 of yacc.c  */
#line 2221 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            }
    break;

  case 155:

/* Line 1806 of yacc.c  */
#line 2225 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                if ((yyvsp[(1) - (3)].instr)->data_type->modifiers & HLSL_MODIFIER_CONST)
                                {
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                            "l-value is const");
                                    return 1;
                                }
                                (yyval.instr) = make_assignment((yyvsp[(1) - (3)].instr), (yyvsp[(2) - (3)].assign_op), BWRITERSP_WRITEMASK_ALL, (yyvsp[(3) - (3)].instr));
                                if (!(yyval.instr))
                                    return 1;
                                (yyval.instr)->loc = loc;
                            }
    break;

  case 156:

/* Line 1806 of yacc.c  */
#line 2242 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_ASSIGN;
                            }
    break;

  case 157:

/* Line 1806 of yacc.c  */
#line 2246 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_ADD;
                            }
    break;

  case 158:

/* Line 1806 of yacc.c  */
#line 2250 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_SUB;
                            }
    break;

  case 159:

/* Line 1806 of yacc.c  */
#line 2254 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_MUL;
                            }
    break;

  case 160:

/* Line 1806 of yacc.c  */
#line 2258 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_DIV;
                            }
    break;

  case 161:

/* Line 1806 of yacc.c  */
#line 2262 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_MOD;
                            }
    break;

  case 162:

/* Line 1806 of yacc.c  */
#line 2266 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_LSHIFT;
                            }
    break;

  case 163:

/* Line 1806 of yacc.c  */
#line 2270 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_RSHIFT;
                            }
    break;

  case 164:

/* Line 1806 of yacc.c  */
#line 2274 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_AND;
                            }
    break;

  case 165:

/* Line 1806 of yacc.c  */
#line 2278 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_OR;
                            }
    break;

  case 166:

/* Line 1806 of yacc.c  */
#line 2282 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_XOR;
                            }
    break;

  case 167:

/* Line 1806 of yacc.c  */
#line 2287 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            }
    break;

  case 168:

/* Line 1806 of yacc.c  */
#line 2291 "hlsl.y"
    {
                                FIXME("Comma expression\n");
                            }
    break;



/* Line 1806 of yacc.c  */
#line 4707 "hlsl.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 2295 "hlsl.y"


static void set_location(struct source_location *loc, const struct YYLTYPE *l)
{
    loc->file = hlsl_ctx.source_file;
    loc->line = l->first_line;
    loc->col = l->first_column;
}

static DWORD add_modifier(DWORD modifiers, DWORD mod, const struct YYLTYPE *loc)
{
    if (modifiers & mod)
    {
        hlsl_report_message(hlsl_ctx.source_file, loc->first_line, loc->first_column, HLSL_LEVEL_ERROR,
                "modifier '%s' already specified", debug_modifiers(mod));
        return modifiers;
    }
    if (mod & (HLSL_MODIFIER_ROW_MAJOR | HLSL_MODIFIER_COLUMN_MAJOR)
            && modifiers & (HLSL_MODIFIER_ROW_MAJOR | HLSL_MODIFIER_COLUMN_MAJOR))
    {
        hlsl_report_message(hlsl_ctx.source_file, loc->first_line, loc->first_column, HLSL_LEVEL_ERROR,
                "more than one matrix majority keyword");
        return modifiers;
    }
    return modifiers | mod;
}

struct bwriter_shader *parse_hlsl(enum shader_type type, DWORD major, DWORD minor,
        const char *entrypoint, char **messages)
{
    struct hlsl_ir_function_decl *function, *next_function;
    struct hlsl_scope *scope, *next_scope;
    struct hlsl_type *hlsl_type, *next_type;
    struct hlsl_ir_var *var, *next_var;
    unsigned int i;

    hlsl_ctx.status = PARSE_SUCCESS;
    hlsl_ctx.messages.size = hlsl_ctx.messages.capacity = 0;
    hlsl_ctx.line_no = hlsl_ctx.column = 1;
    hlsl_ctx.source_file = d3dcompiler_strdup("");
    hlsl_ctx.source_files = d3dcompiler_alloc(sizeof(*hlsl_ctx.source_files));
    if (hlsl_ctx.source_files)
        hlsl_ctx.source_files[0] = hlsl_ctx.source_file;
    hlsl_ctx.source_files_count = 1;
    hlsl_ctx.cur_scope = NULL;
    hlsl_ctx.matrix_majority = HLSL_COLUMN_MAJOR;
    list_init(&hlsl_ctx.scopes);
    list_init(&hlsl_ctx.types);
    list_init(&hlsl_ctx.functions);

    push_scope(&hlsl_ctx);
    hlsl_ctx.globals = hlsl_ctx.cur_scope;
    declare_predefined_types(hlsl_ctx.globals);

    hlsl_parse();

    if (TRACE_ON(hlsl_parser))
    {
        struct hlsl_ir_function_decl *func;

        TRACE("IR dump.\n");
        LIST_FOR_EACH_ENTRY(func, &hlsl_ctx.functions, struct hlsl_ir_function_decl, node.entry)
        {
            if (func->body)
                debug_dump_ir_function(func);
        }
    }

    TRACE("Compilation status = %d\n", hlsl_ctx.status);
    if (messages)
    {
        if (hlsl_ctx.messages.size)
            *messages = hlsl_ctx.messages.string;
        else
            *messages = NULL;
    }
    else
    {
        if (hlsl_ctx.messages.capacity)
            d3dcompiler_free(hlsl_ctx.messages.string);
    }

    for (i = 0; i < hlsl_ctx.source_files_count; ++i)
        d3dcompiler_free((void *)hlsl_ctx.source_files[i]);
    d3dcompiler_free(hlsl_ctx.source_files);

    TRACE("Freeing functions IR.\n");
    LIST_FOR_EACH_ENTRY_SAFE(function, next_function, &hlsl_ctx.functions, struct hlsl_ir_function_decl, node.entry)
        free_function(function);

    TRACE("Freeing variables.\n");
    LIST_FOR_EACH_ENTRY_SAFE(scope, next_scope, &hlsl_ctx.scopes, struct hlsl_scope, entry)
    {
        LIST_FOR_EACH_ENTRY_SAFE(var, next_var, &scope->vars, struct hlsl_ir_var, scope_entry)
        {
            free_declaration(var);
        }
        wine_rb_destroy(&scope->types, NULL, NULL);
        d3dcompiler_free(scope);
    }

    TRACE("Freeing types.\n");
    LIST_FOR_EACH_ENTRY_SAFE(hlsl_type, next_type, &hlsl_ctx.types, struct hlsl_type, entry)
    {
        free_hlsl_type(hlsl_type);
    }

    return NULL;
}

